#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#include <shellapi.h>
#include <stdlib.h>
#include <stdio.h>
#include <commctrl.h>
#include <commdlg.h>
#include "resource.h"

#define NORMAL 0
#define OVER 1
#define CLICK 2
#define ROVER 4
#define RCLICK 5
#define LOVER 7
#define LCLICK 8

const long magicDWord = 0x49474541;

struct Module
{
	HINSTANCE dllInst;
	int (FAR* InitModule)(HINSTANCE, HWND, char*);
	void (FAR* QuitModule)();
	DLGPROC (FAR* ConfigProc)(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
	char* (FAR* QueryConfigId)();
	char* (FAR* QueryName)();
	void (FAR* ShowModuleWindow)(DWORD);
	char path[MAX_PATH];

	struct Module* next;
};

struct Button
{
	HWND hwnd;
	int x, y, w, h;
	char exec[MAX_PATH];
	char name[256];
	HBITMAP nbmp, obmp, cbmp, bg;
	HICON icon;
	HBRUSH iconmask;
	COLORREF iconmaskcolor;
	int ix, iy, iw, ih;
	int STATE;
	BOOL EXTRACT;

	struct Button* next;
};

struct Panel
{
	HWND hwnd, left, right;
	int x, y, w, h, cw, ch, bgw, bgh, ox, oy;
	int lx, ly, rx, ry, lcx, lcy, rcx, rcy;
	int lw, lh, rw, rh;
	HBITMAP bg, cbg, lbmp, lobmp, lcbmp, rbmp, robmp, rcbmp, buttonbg;
	BOOL OPEN, ONALLDESKTOPS, ALWAYSONTOP, SETREGION, NOPARENT;
	int STATE;
	char name[256];
	char leftexec[256], rightexec[256];

	struct Module* modules;
	struct Button* buttons;
	struct Panel* next;
};

struct Panel* start=0;

HINSTANCE hinst = NULL; 
char* AppName = "WinPanel";
char* cfgfile = ".\\winpanel.cfg";
char* bmpfilter = "Bitmap (*.bmp)\0*.bmp\0All Files (*.*)\0*.*\0\0";
char* exefilter = "Executable (*.exe)\0*.exe\0All Files (*.*)\0*.*\0\0";
char labeledit[256] = "";

int ScreenX, ScreenY, PanelCount;
int DesktopLeft, DesktopRight, DesktopTop, DesktopBottom;
HBRUSH transbrush;
char IMAGE_DIR[MAX_PATH] = "";
BOOL APPLY=FALSE;
BOOL CONFIRM_QUIT=TRUE;
BOOL TOOLTIPS=FALSE;
BOOL HIDE_EXPLORER_DESKTOP=FALSE;
BOOL HIDE_EXPLORER_TASKBAR=FALSE;
BOOL APPLY_CHANGES=FALSE;
BOOL QUITTING=FALSE;
HWND ButtonHints=NULL;

LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK LeftEndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK RightEndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK ButtonProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK ConfigProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);

BOOL CALLBACK DialogMainProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK DialogPanelProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK DialogPanelMainProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK DialogPanelLeftProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK DialogPanelRightProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK DialogButtonProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK DialogButtonMainProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);

void BrowseForFile(HWND hwnd, DWORD editbox, char* filter);
void BrowseForModule(HWND hwnd);
void ButtonExecute(HWND hwnd, char* cmd);
void CreateHint(HWND hwnd, char* text, RECT* r);
void LoadPanel(char* panel, HWND parent);
void LoadPanelConfig(HWND hwnd, char* section, HTREEITEM parent);
void LoadSetup();
void RemoveHint(HWND hwnd);
void SavePanelLayout(HWND tv, HTREEITEM hti, char* panel);
void SetWindowBitmapRgn(HWND hwnd, HBITMAP bmp);
void ShowChildren(struct Panel* p, DWORD show);
int TabCtrl_FindItem(HWND tab, char* name);
void WPTransparentBlt(HDC hdc, int dx, int dy, int dw, int dh, HDC buf, int sx, int sy);
void Unload();

UINT WP_COLLAPSE_LEFT, WP_COLLAPSE_RIGHT;

///////////////////////////////
// MAIN!!!!!
///////////////////////////////

int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, 
    LPSTR lpszCmdLine, int nCmdShow) 
{ 
    MSG msg;
	WNDCLASS wc;
	RECT r;

    UNREFERENCED_PARAMETER(lpszCmdLine);

	SystemParametersInfo(SPI_GETWORKAREA, 0, (PVOID)&r, 0);

	hinst = hInstance;  // save instance handle 

	memset(&wc,0,sizeof(wc));
	wc.hInstance = hInstance;
	wc.lpfnWndProc = WndProc;
	wc.lpszClassName = AppName;
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	RegisterClass(&wc);
	
	wc.lpfnWndProc = LeftEndProc;
	wc.lpszClassName = "WPLeftEnd";
	RegisterClass(&wc);

	wc.lpfnWndProc = RightEndProc;
	wc.lpszClassName = "WPRightEnd";
	RegisterClass(&wc);

	wc.lpfnWndProc = ButtonProc;
	wc.lpszClassName = "WPButton";
	RegisterClass(&wc);

	transbrush  = CreateSolidBrush(0x00FF00FF);
	InitCommonControls();
	if (TOOLTIPS)
	{
		ButtonHints = CreateWindow(TOOLTIPS_CLASS, "ButtonHints", TTS_ALWAYSTIP, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, (HMENU) NULL, hinst, NULL);
		if (ButtonHints) SetWindowPos(ButtonHints, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE|SWP_NOACTIVATE);
	}

	LoadSetup();

	while (GetMessage(&msg, (HWND) NULL, 0, 0))
    { 
        TranslateMessage(&msg); 
        DispatchMessage(&msg); 
    }
	
	Unload();
	if (TOOLTIPS) DestroyWindow(ButtonHints);
	DeleteObject(transbrush);
	UnregisterClass(AppName, hinst);
	UnregisterClass("WPLeftEndProc", hinst);
	UnregisterClass("WPRightEndProc", hinst);
	UnregisterClass("WPButton", hinst);

	if (HIDE_EXPLORER_DESKTOP)
	{
		HWND explorer = FindWindow("Progman", NULL);
		ShowWindow(explorer, SW_SHOW);
	}

	if (HIDE_EXPLORER_TASKBAR)
	{
		HWND taskbar = FindWindow("Shell_TrayWnd", NULL);
		ShowWindow(taskbar, SW_SHOW);
	}

	SystemParametersInfo(SPI_SETWORKAREA,0,(PVOID)&r,SPIF_SENDCHANGE);

	return msg.wParam; 
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch(message)
	{
		case WM_SYSCOMMAND:
		{
			switch (wParam)
			{
				case SC_CLOSE: return 0;
			}
		}
		break;

		case WM_NCPAINT:
		case WM_PAINT:
		{
			PAINTSTRUCT ps;
			HDC hdc = BeginPaint(hwnd, &ps);
			HDC buf = CreateCompatibleDC(NULL);
			HBITMAP oldBmp=NULL;
			struct Panel* p = (struct Panel*)GetProp(hwnd, "PanelStruct");
			int x;

			if (p)
			{
				if (!p->SETREGION)
				{
					RECT r;
					HRGN rgn;
					GetClientRect(hwnd, &r);
					rgn = CreateRectRgn(r.left, r.top, r.right, r.bottom);
					SetWindowRgn(hwnd, rgn, FALSE);
				}

				if (p->OPEN) 
				{
					HDC tile = CreateCompatibleDC(NULL);
					HBITMAP tilebmp = CreateCompatibleBitmap(hdc, p->w, p->h), oldtileBmp;

					oldtileBmp = SelectObject(tile, tilebmp);
					oldBmp = SelectObject(buf, p->bg);
					for (x=0; x < p->w; x += p->bgw)
					{
						BitBlt(tile, x, 0, p->bgw, p->bgh, buf, 0, 0, SRCCOPY);
					}
					BitBlt(hdc, 0, 0, p->w, p->h, tile, 0, 0, SRCCOPY);
					SelectObject(tile, oldtileBmp);
					DeleteObject(tilebmp);
					DeleteDC(tile);
					DeleteObject(oldtileBmp);
				}
				else 
				{
					oldBmp = (HBITMAP)SelectObject(buf, p->cbg);
					BitBlt(hdc, 0, 0, p->w, p->h, buf, 0, 0, SRCCOPY);
				}

				if (!p->SETREGION)
				{
					HDC rgn = CreateCompatibleDC(NULL);
					HBITMAP rgnbmp = CreateCompatibleBitmap(hdc, p->w, p->h), oldrgnbmp;
					oldrgnbmp = SelectObject(rgn, rgnbmp);
					BitBlt(rgn, 0, 0, p->w, p->h, hdc, 0, 0, SRCCOPY);
					SetWindowBitmapRgn(hwnd, rgnbmp);
					SelectObject(rgn, oldrgnbmp);
					DeleteObject(rgnbmp);
					DeleteDC(rgn);
					DeleteObject(oldrgnbmp);
					p->SETREGION=TRUE;
					InvalidateRect(hwnd, NULL, TRUE);
				}
			}
			
			SelectObject(buf, oldBmp);
			DeleteDC(buf);

			EndPaint(hwnd, &ps);
			p=NULL;
			free(p);
		}
		break;

		case WM_NCHITTEST: 
		{
			if (GetWindowLong(hwnd, GWL_STYLE) & WS_CHILD) return HTCLIENT;
			else return HTCAPTION;
		}

		case WM_MOVE:
		{
			struct Panel* p = (struct Panel*)GetProp(hwnd, "PanelStruct");
			
			if (p)
			{
				if (p->NOPARENT)
				{
					char temp[256] = "";
					sprintf(temp, "%d", (int)LOWORD(lParam));
					WritePrivateProfileString(p->name, "X", temp, cfgfile);
					sprintf(temp, "%d", (int)HIWORD(lParam));
					WritePrivateProfileString(p->name, "Y", temp, cfgfile);
				}
			}

			p=NULL;
			free(p);
		}
		break;

		case WM_WINDOWPOSCHANGING:
		{
			WINDOWPOS* wp = (WINDOWPOS*)lParam;

			if (!(wp->flags & SWP_NOMOVE))
			{
				struct Panel* p = (struct Panel*)GetProp(hwnd, "PanelStruct");
				
				if (p)
				{
					int w=p->cw, h=p->ch;
					char temp[256] = "";

					if (p->OPEN) { w=p->w; h=p->h; }

					if (wp->x < 5 && wp->x > -5) wp->x = 0;
					else if (wp->x+w > (ScreenX - 5) && wp->x+w < ScreenX + 5) wp->x = ScreenX - w;
					if (wp->y < 5 && wp->y > -5) wp->y = 0;
					else if (wp->y+h > (ScreenY-5) && wp->y+h < ScreenY + 5) wp->y = ScreenY - h;
					p->x = wp->x;
					p->y = wp->y;
				}

				p=NULL;
				free(p);
			}
		}
		break;
	
		default:
		{
			if (message == WP_COLLAPSE_LEFT)
			{
				struct Panel* p = (struct Panel*)GetProp(hwnd, "PanelStruct");
				if (p->OPEN)
				{
					SetWindowPos(p->hwnd, 0, 0, 0, p->cw, p->ch, SWP_NOMOVE | SWP_NOZORDER);
					SetWindowPos(p->right, 0, p->rcx, p->rcy, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
					SetWindowBitmapRgn(p->hwnd, p->cbg);
					ShowChildren(p, SW_HIDE);
					p->OPEN=FALSE;
				}
				else
				{
					SetWindowPos(p->hwnd, 0, 0, 0, p->w, p->h, SWP_NOMOVE | SWP_NOZORDER | SWP_NOREDRAW);
					SetWindowPos(p->right, 0, p->rx, p->ry, 0, 0, SWP_NOZORDER | SWP_NOSIZE | SWP_NOREDRAW);
					p->OPEN=TRUE;
					p->SETREGION=FALSE;
					ShowChildren(p, SW_SHOW);
				}
				InvalidateRect(p->hwnd, NULL, TRUE);
			}
			else if (message == WP_COLLAPSE_RIGHT)
			{
				struct Panel* p = (struct Panel*)GetProp(hwnd, "PanelStruct");

				if (p->OPEN)
				{
					RECT r;
					GetWindowRect(p->hwnd, &r);
					p->ox = r.left;
					p->oy = r.top;
					SetWindowPos(p->hwnd, 0, r.right - p->cw, r.top, p->cw, p->ch, SWP_NOZORDER);
					SetWindowPos(p->right, 0, p->rcx, p->rcy, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
					SetWindowBitmapRgn(p->hwnd, p->cbg);
					ShowChildren(p, SW_HIDE);
					p->OPEN=FALSE;
				}
				else
				{
					SetWindowPos(p->hwnd, 0, p->ox, p->oy, p->w, p->h, SWP_NOZORDER);
					SetWindowPos(p->right, 0, p->rx, p->ry, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
					p->OPEN=TRUE;
					p->SETREGION=FALSE;
					ShowChildren(p, SW_SHOW);
				}
				InvalidateRect(p->hwnd, NULL, TRUE);
			}
		}
		break;
	}

	return DefWindowProc(hwnd, message, wParam, lParam);
}

LRESULT CALLBACK LeftEndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg)
	{
		case WM_PAINT:
		{
			PAINTSTRUCT ps;
			HDC hdc = BeginPaint(hwnd, &ps);
			HDC buf = CreateCompatibleDC(NULL);
			HBITMAP oldBmp=NULL;
			struct Panel* p = (struct Panel*)GetProp(GetParent(hwnd), "PanelStruct");

			if (p)
			{
				if (p->STATE == LOVER) 
				{
					if (p->lobmp) oldBmp = (HBITMAP)SelectObject(buf, p->lobmp);
					else oldBmp = (HBITMAP)SelectObject(buf, p->lbmp);
				}
				else if (p->STATE == LCLICK)
				{
					if (p->lcbmp) oldBmp = (HBITMAP)SelectObject(buf, p->lcbmp);
					else if (p->lobmp) oldBmp = (HBITMAP)SelectObject(buf, p->lobmp);
					else oldBmp = (HBITMAP)SelectObject(buf, p->lbmp);
				}
				else
				{
					oldBmp = (HBITMAP)SelectObject(buf, p->lbmp);
				}

				BitBlt(hdc, 0, 0, p->lw, p->lh, buf, 0, 0, SRCCOPY);
			}

			SelectObject(buf, oldBmp);
			DeleteDC(buf);
			
			EndPaint(hwnd, &ps);
			p=NULL;
			free(p);
		}
		break;

		case WM_LBUTTONDOWN:
		{
			struct Panel* p = (struct Panel*)GetProp(GetParent(hwnd), "PanelStruct");

			if (p->STATE != LCLICK)
			{
				p->STATE=LCLICK;
				SetWindowBitmapRgn(hwnd, p->lcbmp);
				InvalidateRect(hwnd, NULL, TRUE);
			}
			p=NULL;
			free(p);
		}
		break;

		case WM_LBUTTONUP:
		{
			struct Panel* p = (struct Panel*)GetProp(GetParent(hwnd), "PanelStruct");

			if (p)
			{
				p->STATE=LOVER;
				SetWindowBitmapRgn(hwnd, p->lobmp);
				InvalidateRect(hwnd, NULL, TRUE);
				ButtonExecute(p->hwnd, p->leftexec);
			}
			p=NULL;
			free(p);
		}
		break;

		case WM_MOUSEMOVE:
		{
			struct Panel* p = (struct Panel*)GetProp(GetParent(hwnd), "PanelStruct");
			
			if (p->STATE != LOVER)
			{
				p->STATE=LOVER;
				SetWindowBitmapRgn(hwnd, p->lobmp);
				InvalidateRect(hwnd, NULL, TRUE);
				SetTimer(hwnd, 0, 5, NULL);
			}
			p=NULL;
			free(p);
		}
		break;

		case WM_TIMER:
		{
			struct Panel* p = (struct Panel*)GetProp(GetParent(hwnd), "PanelStruct");
			HRGN rgn=CreateRectRgn(0, 0, 0, 0);
			RECT r;
			POINT po;
			
			GetCursorPos(&po);
			GetWindowRgn(hwnd, rgn);
			GetWindowRect(hwnd, &r);
			
			if (!PtInRegion(rgn, po.x - r.left, po.y - r.top))
			{
				KillTimer(hwnd, 0);
				p->STATE=NORMAL;
				SetWindowBitmapRgn(hwnd, p->lbmp);
				InvalidateRect(hwnd, NULL, TRUE);
			}
			p=NULL;
			free(p);
		}
		break;
	}

	return DefWindowProc(hwnd, msg, wParam, lParam);
}

LRESULT CALLBACK RightEndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg)
	{
		case WM_PAINT:
		{
			PAINTSTRUCT ps;
			HDC hdc = BeginPaint(hwnd, &ps);
			HDC buf = CreateCompatibleDC(NULL);
			HBITMAP oldBmp=NULL;
			struct Panel* p = (struct Panel*)GetProp(GetParent(hwnd), "PanelStruct");

			if (p)
			{
				if (p->STATE == ROVER) 
				{
					if (p->robmp) oldBmp = (HBITMAP)SelectObject(buf, p->robmp);
					else oldBmp = (HBITMAP)SelectObject(buf, p->rbmp);
				}
				else if (p->STATE == RCLICK)
				{
					if (p->rcbmp) oldBmp = (HBITMAP)SelectObject(buf, p->rcbmp);
					else if (p->robmp) oldBmp = (HBITMAP)SelectObject(buf, p->robmp);
					else oldBmp = (HBITMAP)SelectObject(buf, p->rbmp);
				}
				else
				{
					oldBmp = (HBITMAP)SelectObject(buf, p->rbmp);
				}

				BitBlt(hdc, 0, 0, p->rw, p->rh, buf, 0, 0, SRCCOPY);
			}

			SelectObject(buf, oldBmp);
			DeleteDC(buf);

			EndPaint(hwnd, &ps);
			p=NULL;
			free(p);
		}
		break;

		case WM_LBUTTONDOWN:
		{
			struct Panel* p = (struct Panel*)GetProp(GetParent(hwnd), "PanelStruct");

			if (p->STATE != RCLICK)
			{
				p->STATE=RCLICK;
				SetWindowBitmapRgn(hwnd, p->rcbmp);
				InvalidateRect(hwnd, NULL, TRUE);
			}
			p=NULL;
			free(p);
		}
		break;

		case WM_LBUTTONUP:
		{
			struct Panel* p = (struct Panel*)GetProp(GetParent(hwnd), "PanelStruct");

			if (p)
			{
				p->STATE=ROVER;
				SetWindowBitmapRgn(hwnd, p->robmp);
				InvalidateRect(hwnd, NULL, TRUE);
				ButtonExecute(p->hwnd, p->rightexec);
			}
			p=NULL;
			free(p);
		}
		break;

		case WM_MOUSEMOVE:
		{
			struct Panel* p = (struct Panel*)GetProp(GetParent(hwnd), "PanelStruct");
			
			if (p->STATE != ROVER)
			{
				p->STATE=ROVER;
				SetWindowBitmapRgn(hwnd, p->robmp);
				InvalidateRect(hwnd, NULL, TRUE);
				SetTimer(hwnd, 0, 5, NULL);
			}
			p=NULL;
			free(p);
		}
		break;

		case WM_TIMER:
		{
			struct Panel* p = (struct Panel*)GetProp(GetParent(hwnd), "PanelStruct");
			HRGN rgn=CreateRectRgn(0, 0, 0, 0);
			RECT r;
			POINT po;
			
			GetCursorPos(&po);
			GetWindowRgn(hwnd, rgn);
			GetWindowRect(hwnd, &r);
			
			if (!PtInRegion(rgn, po.x - r.left, po.y - r.top))
			{
				KillTimer(hwnd, 0);
				p->STATE=NORMAL;
				SetWindowBitmapRgn(hwnd, p->rbmp);
				InvalidateRect(hwnd, NULL, TRUE);
			}
			p=NULL;
			free(p);
		}
		break;
	}

	return DefWindowProc(hwnd, msg, wParam, lParam);
}

LRESULT CALLBACK ButtonProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg)
	{
		case WM_PAINT:
		{
			PAINTSTRUCT ps;
			HDC hdc = BeginPaint(hwnd, &ps);
			HDC buf = CreateCompatibleDC(NULL);
			HBITMAP oldBmp=NULL;
			struct Button* b = (struct Button*)GetWindowLong(hwnd, GWL_USERDATA);
			
			if (b)
			{
				if (!b->EXTRACT)
				{
					HDC buf2 = CreateCompatibleDC(NULL);
					HBITMAP buf2bmp = CreateCompatibleBitmap(hdc, b->w, b->h);
					HBITMAP old2Bmp;

					if (b->STATE == OVER) 
					{
						if (b->obmp) oldBmp = (HBITMAP)SelectObject(buf, b->obmp);
						else oldBmp = (HBITMAP)SelectObject(buf, b->nbmp);
					}
					else if (b->STATE == CLICK)
					{
						if (b->cbmp) oldBmp = (HBITMAP)SelectObject(buf, b->cbmp);
						else if (b->obmp) oldBmp = (HBITMAP)SelectObject(buf, b->obmp);
						else oldBmp = (HBITMAP)SelectObject(buf, b->nbmp);
					}
					else if (b->STATE == NORMAL)
					{
						oldBmp = (HBITMAP)SelectObject(buf, b->nbmp);
					}

					old2Bmp = SelectObject(buf2, buf2bmp);
					WPTransparentBlt(buf2, 0, 0, b->w, b->h, buf, 0, 0);
					BitBlt(hdc, 0, 0, b->w, b->h, buf2, 0, 0, SRCCOPY);
					SelectObject(buf2, old2Bmp);
					DeleteObject(buf2bmp);
					DeleteDC(buf2);
					DeleteObject(old2Bmp);
				}
				else
				{
					HDC iconhdc = CreateCompatibleDC(NULL);
					HDC bg = CreateCompatibleDC(NULL);
					HBITMAP iconbmp = CreateCompatibleBitmap(hdc, b->iw, b->ih);
					HBITMAP bufbmp = CreateCompatibleBitmap(hdc, b->w, b->h);
					HBITMAP oldicon, oldbg;
					
					oldicon = (HBITMAP)SelectObject(iconhdc, iconbmp);
					DrawIconEx(iconhdc, 0, 0, b->icon, b->iw, b->ih, 0, transbrush, DI_NORMAL);

					oldBmp = (HBITMAP)SelectObject(buf, bufbmp);
					oldbg = (HBITMAP)SelectObject(bg, b->bg);
					BitBlt(buf, 0, 0, b->w, b->h, bg, 0, 0, SRCCOPY);
					
					WPTransparentBlt(buf, b->ix, b->iy, b->iw, b->ih, iconhdc, 0, 0);
					
					if (b->STATE == OVER)
					{
						if (!b->obmp)
						{
							HDC maskhdc = CreateCompatibleDC(NULL);
							HBITMAP maskbmp = CreateCompatibleBitmap(hdc, b->w, b->h);
							HBITMAP oldmask;
							RECT r;

							oldmask = (HBITMAP)SelectObject(maskhdc, maskbmp);
							GetClientRect(hwnd, &r);
							FillRect(maskhdc, &r, b->iconmask);
							BitBlt(maskhdc, 0, 0, b->w, b->h, buf, 0, 0, SRCAND);
							BitBlt(hdc, 0, 0, b->w, b->h, maskhdc, 0, 0, SRCCOPY);
							SelectObject(maskhdc, oldmask);
							DeleteObject(maskbmp);
							DeleteDC(maskhdc);
						}
						else
						{
							HDC mask = CreateCompatibleDC(buf);
							HBITMAP oldmask;
							oldmask = SelectObject(mask, b->obmp);
							WPTransparentBlt(buf, 0, 0, b->w, b->h, mask, 0, 0);
							BitBlt(hdc, 0, 0, b->w, b->h, buf, 0, 0, SRCCOPY);
							SelectObject(mask, oldmask);
							DeleteDC(mask);
							DeleteObject(oldmask);
						}
					}
					else if (b->STATE == NORMAL)
					{
						BitBlt(hdc, 0, 0, b->w, b->h, buf, 0, 0, SRCCOPY);
					}

					SelectObject(buf, oldBmp);
					SelectObject(iconhdc, oldicon);
					SelectObject(bg, oldbg);
					DeleteDC(iconhdc);
					DeleteDC(bg);
					DeleteObject(bufbmp);
					DeleteObject(iconbmp);
				}
			}

			SelectObject(buf, oldBmp);
			DeleteDC(buf);

			EndPaint(hwnd, &ps);
			b=NULL;
			free(b);
		}
		break;

		case WM_MOUSEMOVE:
		{
			struct Button* b = (struct Button*)GetWindowLong(hwnd, GWL_USERDATA);
			MSG TooltipMessage;

			if (b->STATE != OVER)
			{
				b->STATE=OVER;
				InvalidateRect(hwnd, NULL, TRUE);
				SetTimer(hwnd, 0, 5, NULL);
			}

			if (TOOLTIPS)
			{
				TooltipMessage.hwnd=hwnd;
				TooltipMessage.message=msg;
				TooltipMessage.wParam=wParam;
				TooltipMessage.lParam=lParam;
				SendMessage(ButtonHints, TTM_RELAYEVENT, 0, (LPARAM)&TooltipMessage);
				SetWindowPos(ButtonHints, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
			}

			b=NULL;
			free(b);
		}
		break;

		case WM_LBUTTONDOWN:
		{
			struct Button* b = (struct Button*)GetWindowLong(hwnd, GWL_USERDATA);

			if (b->STATE != CLICK)
			{
				b->STATE=CLICK;
				InvalidateRect(hwnd, NULL, TRUE);
			}
			b=NULL;
			free(b);
		}
		break;

		case WM_LBUTTONUP:
		{
			struct Button* b = (struct Button*)GetWindowLong(hwnd, GWL_USERDATA);

			if (b)
			{
				b->STATE=OVER;
				ButtonExecute(GetParent(b->hwnd), b->exec);
				InvalidateRect(hwnd, NULL, TRUE);
			}

			b=NULL;
			free(b);
		}
		break;

		case WM_TIMER:
		{
			struct Button* b = (struct Button*)GetWindowLong(hwnd, GWL_USERDATA);
			RECT r;
			POINT p;
			
			GetCursorPos(&p);
			GetWindowRect(hwnd, &r);
			
			if (!PtInRect(&r, p))
			{
				KillTimer(hwnd, 0);
				b->STATE=NORMAL;
				InvalidateRect(hwnd, NULL, TRUE);
			}

			b=NULL;
			free(b);
		}
		break;
	}

	return DefWindowProc(hwnd, msg, wParam, lParam);
}

void LoadSetup()
{
	char temp[256] = "";
	char panel[256] = "";
	int x=1;
	HWND parent=NULL;
	RECT r;

	QUITTING=FALSE;

	WP_COLLAPSE_LEFT = RegisterWindowMessage("WP_COLLAPSE_LEFT");
	WP_COLLAPSE_RIGHT = RegisterWindowMessage("WP_COLLAPSE_RIGHT");

	ScreenX = GetSystemMetrics(SM_CXSCREEN);
	ScreenY = GetSystemMetrics(SM_CYSCREEN);
	
	HIDE_EXPLORER_DESKTOP = GetPrivateProfileInt("Main", "HideExplorerDesktop", 0, cfgfile);
	if (HIDE_EXPLORER_DESKTOP)
	{
		HWND explorer = FindWindow("Progman", NULL);
		ShowWindow(explorer, SW_HIDE);
	}
	
	HIDE_EXPLORER_TASKBAR = GetPrivateProfileInt("Main", "HideExplorerTaskbar", 0, cfgfile);
	if (HIDE_EXPLORER_TASKBAR)
	{
		HWND taskbar = FindWindow("Shell_TrayWnd", NULL);
		ShowWindow(taskbar, SW_HIDE);
	}

	SystemParametersInfo(SPI_GETWORKAREA, 0, (PVOID)&r, 0);
	DesktopLeft = GetPrivateProfileInt("Main", "DesktopLeft", r.left, cfgfile);
	DesktopRight = GetPrivateProfileInt("Main", "DesktopRight", r.right, cfgfile);
	DesktopTop = GetPrivateProfileInt("Main", "DesktopTop", r.top, cfgfile);
	DesktopBottom = GetPrivateProfileInt("Main", "DesktopBottom", r.bottom, cfgfile);
	
	if (DesktopRight <= 0) DesktopRight += ScreenX;
	if (DesktopBottom <= 0) DesktopBottom += ScreenY;
	SetRect(&r, DesktopLeft, DesktopTop, DesktopRight, DesktopBottom);
	SystemParametersInfo(SPI_SETWORKAREA,0,(PVOID)&r,SPIF_SENDCHANGE);

	CONFIRM_QUIT = GetPrivateProfileInt("Main", "ConfirmQuit", 1, cfgfile);
	GetPrivateProfileString("Main", "ImageDirectory", "c:\\winpanel\\images\\", IMAGE_DIR, MAX_PATH, cfgfile);
	if (IMAGE_DIR[strlen(IMAGE_DIR)-1] != '\\')
	{
		IMAGE_DIR[strlen(IMAGE_DIR)] = '\\';
		IMAGE_DIR[strlen(IMAGE_DIR)+1] = '\0';
	}

	while (strcmp(panel, "no more honky"))
	{
		sprintf(temp, "Panel%d", x++);
		GetPrivateProfileString("main", temp, "no more honky", panel, 256, cfgfile);
		if (!strcmp(panel, "no more honky")) break;
		LoadPanel(panel, parent);
	}
}

void LoadPanel(char* panel, HWND parent)
{
	struct Panel* p = (struct Panel*)malloc(sizeof(struct Panel));
	char temp[256] = "";
	char path[256] = "";
	char button[256] = "";
	char childpanel[256] = "";
	char module[256] = "";
	int count=1;
	int x=1;
	int xp=0, yp=0;

	// Change this for startup state
	strcpy(p->name, panel);
	p->buttons = 0;
	p->modules = 0;
	p->STATE = NORMAL;

	if (!parent) p->NOPARENT = TRUE;
	p->OPEN = GetPrivateProfileInt(panel, "OpenState", 1, cfgfile);
	p->ONALLDESKTOPS = GetPrivateProfileInt(panel, "OnAllDesktops", 0, cfgfile);
	p->ALWAYSONTOP = GetPrivateProfileInt(panel, "AlwaysOnTop", 0, cfgfile);
	p->SETREGION = FALSE;

	p->x = GetPrivateProfileInt(panel, "X", 0, cfgfile);
	if (p->x < 0) p->x = ScreenX + p->x;
	p->y = GetPrivateProfileInt(panel, "Y", 0, cfgfile);
	if (p->y < 0) p-> y = ScreenY + p->y;

	p->w = GetPrivateProfileInt(panel, "W", 0, cfgfile);
	p->h = GetPrivateProfileInt(panel, "H", 0, cfgfile);
	
	GetPrivateProfileString(panel, "Open", "", temp, 256, cfgfile);
	sprintf(path, "%s%s", IMAGE_DIR, temp);
	p->bg = LoadImage(NULL, path, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);

	GetPrivateProfileString(panel, "Closed", "", temp, 256, cfgfile);
	sprintf(path, "%s%s", IMAGE_DIR, temp);
	p->cbg = LoadImage(NULL, path, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);

	GetPrivateProfileString(panel, "Left", "", temp, 256, cfgfile);
	sprintf(path, "%s%s", IMAGE_DIR, temp);
	p->lbmp = LoadImage(NULL, path, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
	p->lx = GetPrivateProfileInt(panel, "LeftX", 0, cfgfile);
	p->ly = GetPrivateProfileInt(panel, "LeftY", 0, cfgfile);

	GetPrivateProfileString(panel, "LeftOver", "", temp, 256, cfgfile);
	sprintf(path, "%s%s", IMAGE_DIR, temp);
	p->lobmp = LoadImage(NULL, path, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);

	GetPrivateProfileString(panel, "LeftClick", "", temp, 256, cfgfile);
	sprintf(path, "%s%s", IMAGE_DIR, temp);
	p->lcbmp = LoadImage(NULL, path, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);

	GetPrivateProfileString(panel, "LeftExecute", "!WinPanelCollapseRight", p->leftexec, 256, cfgfile);

	GetPrivateProfileString(panel, "Right", "", temp, 256, cfgfile);
	sprintf(path, "%s%s", IMAGE_DIR, temp);
	p->rbmp = LoadImage(NULL, path, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
	p->rx = GetPrivateProfileInt(panel, "RightX", 0, cfgfile);
	p->ry = GetPrivateProfileInt(panel, "RightY", 0, cfgfile);

	GetPrivateProfileString(panel, "RightOver", "", temp, 256, cfgfile);
	sprintf(path, "%s%s", IMAGE_DIR, temp);
	p->robmp = LoadImage(NULL, path, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);

	GetPrivateProfileString(panel, "RightClick", "", temp, 256, cfgfile);
	sprintf(path, "%s%s", IMAGE_DIR, temp);
	p->rcbmp = LoadImage(NULL, path, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
	
	GetPrivateProfileString(panel, "RightExecute", "!WinPanelCollapseLeft", p->rightexec, 256, cfgfile);

	if (p->bg && p->cbg)
	{
		BITMAP bmp;
		GetObject(p->bg, sizeof(bmp), &bmp);
		p->bgw = bmp.bmWidth;
		p->bgh = bmp.bmHeight;
		if (!p->w) p->w = bmp.bmWidth;
		if (!p->h) p->h = bmp.bmHeight;
		if (parent) p->hwnd = CreateWindowEx(WS_EX_TOOLWINDOW, AppName, AppName, WS_CHILD, p->x, p->y, p->w, p->h, parent, NULL, hinst, 0);
		else p->hwnd = CreateWindowEx(WS_EX_TOOLWINDOW, AppName, AppName, WS_POPUP, p->x, p->y, p->w, p->h, NULL, NULL, hinst, 0);
		if (!p->hwnd) return;
		
		if (p->ONALLDESKTOPS) SetWindowLong(p->hwnd, GWL_USERDATA, magicDWord); 
		if (p->ALWAYSONTOP) SetWindowPos(p->hwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE);

		GetObject(p->cbg, sizeof(bmp), &bmp);
		p->cw = bmp.bmWidth;
		p->ch = bmp.bmHeight;

		if (p->lbmp)
		{
			GetObject(p->lbmp, sizeof(bmp), &bmp);
			p->lw = bmp.bmWidth;
			p->lh = bmp.bmHeight;
			if (p->lx < 0) { p->lx = p->w + p->lx; p->lcx = p->lw + p->lx; }
			if (p->ly < 0) { p->ly = p->h + p->ly; p->lcy = p->lh + p->ly; }
			p->left = CreateWindowEx(0, "WPLeftEnd", AppName, WS_CHILD | WS_VISIBLE, xp, yp, p->lw, p->lh, p->hwnd, NULL, hinst, 0);
			if (!p->left) return;
			SetWindowBitmapRgn(p->left, p->lbmp);
		}

		if (p->rbmp)
		{
			GetObject(p->rbmp, sizeof(bmp), &bmp);
			p->rw = bmp.bmWidth;
			p->rh = bmp.bmHeight;
			if (p->rx < 0) { p->rcx = p->cw + p->rx; p->rx = p->w + p->rx; }
			if (p->ry < 0) { p->rcy = p->ch + p->ry; p->ry = p->h + p->ry; }
			p->right = CreateWindowEx(0, "WPRightEnd", AppName, WS_CHILD | WS_VISIBLE, p->rx, p->ry, p->rw, p->rh, p->hwnd, NULL, hinst, 0);
			if (!p->right) return;
			SetWindowBitmapRgn(p->right, p->rbmp);
		}

		x=1;
		while (strcmp(module, "no more honky"))
		{
			struct Module* m = (struct Module*)malloc(sizeof(struct Module));

			sprintf(temp, "Module%d", x++);
			GetPrivateProfileString(panel, temp, "no more honky", module, 256, cfgfile);
			if (!strcmp(module, "no more honky")) break;
			
			strcpy(m->path, module);
			m->dllInst = LoadLibrary(module);
			if (m->dllInst)
			{
				m->InitModule = (int (FAR*)(HINSTANCE, HWND, char*))GetProcAddress(m->dllInst, "InitModule");
				m->QuitModule = (void (FAR*)())GetProcAddress(m->dllInst, "QuitModule");
				m->ConfigProc = (DLGPROC (FAR*)(HWND, UINT, WPARAM, LPARAM))GetProcAddress(m->dllInst, "DialogConfigProc");
				m->QueryConfigId = (char* (FAR*)())GetProcAddress(m->dllInst, "QueryConfigId");
				m->QueryName = (char* (FAR*)())GetProcAddress(m->dllInst, "QueryName");
				m->ShowModuleWindow = (void (FAR*)(DWORD))GetProcAddress(m->dllInst, "ShowModuleWindow");
				m->InitModule(m->dllInst, p->hwnd, cfgfile);

				if (m->InitModule && m->QuitModule)
				{
					m->next = 0;
					if (p->modules) m->next = p->modules;
					p->modules = m;
				}
			}
			else
			{
				char error[256] = "";
				sprintf(error, "Unable to load module \"%s\".", module);
				MessageBox(p->hwnd, error, AppName, MB_SYSTEMMODAL | MB_ICONERROR);
			}

			m=NULL;
			free(m);
		}

		x=1;
		while (strcmp(childpanel, "no more honky"))
		{
			sprintf(temp, "Panel%d", x++);
			GetPrivateProfileString(panel, temp, "no more honky", childpanel, 256, cfgfile);
			if (!strcmp(childpanel, "no more honky")) break;
			LoadPanel(childpanel, p->hwnd);
		}

		count=1;
		while (strcmp(button, "no more honky"))
		{
			struct Button* b = (struct Button*)malloc(sizeof(struct Button));
			RECT r;

			sprintf(temp, "Button%d", count++);
			GetPrivateProfileString(panel, temp, "no more honky", button, 256, cfgfile);
			if (!strcmp(button, "no more honky")) break;

			strcpy(b->name, button);
			b->x = GetPrivateProfileInt(button, "X", 0, cfgfile);
			if (b->x < 0) b->x += p->w;
			b->y = GetPrivateProfileInt(button, "Y", 0, cfgfile);
			if (b->y < 0) b->y += p->h;
			b->w = GetPrivateProfileInt(button, "W", 0, cfgfile);
			b->h = GetPrivateProfileInt(button, "H", 0, cfgfile);
			GetPrivateProfileString(button, "Execute", "", b->exec, 256, cfgfile);
			b->STATE=NORMAL;
			b->EXTRACT=FALSE;
				
			GetPrivateProfileString(button, "Background", "", temp, 256, cfgfile);
			sprintf(path, "%s%s", IMAGE_DIR, temp);
			b->bg = LoadImage(NULL, path, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);

			GetPrivateProfileString(button, "Normal", "", temp, 256, cfgfile);
			if (!_strnicmp(temp, ".extract", 8))
			{
				char *e = strtok(temp, ",");
				int num=0;
				
				b->EXTRACT = TRUE;
				sprintf(path, "%s", temp+9);
				e = strtok(NULL, " ,");
				num = atoi(e);
				e = strtok(NULL, " ,");
				b->ix = atoi(e);
				e = strtok(NULL, " ,");
				b->iy = atoi(e);
				e = strtok(NULL, " ,");
				b->iw = atoi(e);
				e = strtok(NULL, " ,");
				b->ih = atoi(e);
				b->icon = ExtractIcon(hinst, path, num);

				GetPrivateProfileString(button, "Over", "0", temp, 256, cfgfile);
				b->iconmaskcolor = strtol( temp, &e, 16 );
				b->iconmask = CreateSolidBrush(b->iconmaskcolor);
			}
			else
			{
				sprintf(path, "%s%s", IMAGE_DIR, temp);
				b->nbmp = LoadImage(NULL, path, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
			}

			GetPrivateProfileString(button, "Over", "", temp, 256, cfgfile);
			sprintf(path, "%s%s", IMAGE_DIR, temp);
			b->obmp = LoadImage(NULL, path, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
			
			GetPrivateProfileString(button, "Click", "", temp, 256, cfgfile);
			sprintf(path, "%s%s", IMAGE_DIR, temp);
			b->cbmp = LoadImage(NULL, path, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
			
			if (b->nbmp)
			{
				BITMAP bmp;
				GetObject(b->nbmp, sizeof(bmp), &bmp);
				if (b->w == 0) b->w = bmp.bmWidth;
				if (b->h == 0) b->h = bmp.bmHeight;
				b->hwnd = CreateWindow("WPButton", b->exec, WS_CHILD | WS_VISIBLE, b->x, b->y, b->w, b->h, p->hwnd, NULL, hinst, 0);
			}
			else if (b->icon)
			{
				b->hwnd = CreateWindow("WPButton", b->exec, WS_CHILD | WS_VISIBLE, b->x, b->y, b->w, b->h, p->hwnd, NULL, hinst, 0);
			}
			
			if (!b->hwnd) continue;
			SetWindowLong(b->hwnd, GWL_USERDATA, (long)b);
			
			if (TOOLTIPS)
			{
				GetClientRect(b->hwnd, &r);
				CreateHint(b->hwnd, b->name, &r);
			}

			b->next = 0;
			if (p->buttons) b->next = p->buttons;
			p->buttons = b;

			b = NULL;
			free(b);
		}

		p->next = 0;
		if (start) p->next = start;
		start = p;

		SetProp(p->hwnd, "PanelStruct", (HANDLE)p);

		ShowWindow(p->hwnd, SW_SHOWNORMAL);
		PanelCount++;
	}
	else
	{
		DeleteObject(p->bg);
		DeleteObject(p->cbg);
		DeleteObject(p->lbmp);
		DeleteObject(p->lcbmp);
		DeleteObject(p->lobmp);
		DeleteObject(p->rbmp);
		DeleteObject(p->rcbmp);
		DeleteObject(p->robmp);
	}

	p = NULL;
	free(p);
}

void SetWindowBitmapRgn(HWND hwnd, HBITMAP bmp)
{
	if (hwnd && bmp)
	{
		int x=0, y=0;
		HDC hdc = CreateCompatibleDC(NULL);
		HRGN hTransRgn=NULL;
		HRGN hMainRgn=NULL;
		BITMAP bitmap;

		GetObject(bmp, sizeof(bitmap), &bitmap);
		SelectObject(hdc, bmp);
		hMainRgn = CreateRectRgn(0, 0, bitmap.bmWidth, bitmap.bmHeight);

		for (y=0; y < bitmap.bmHeight; x=0, y++)
		{
			for (x=0; x < bitmap.bmWidth; x++)
			{
				COLORREF c = GetPixel(hdc, x, y);
				if (c == 0x00FF00FF)
				{
					HRGN hTempRgn = CreateRectRgn(x, y, x+1, y+1);
					if (!hTransRgn) hTransRgn = CreateRectRgn(x, y, x+1, y+1);
					CombineRgn(hTransRgn, hTransRgn, hTempRgn, RGN_OR);
					DeleteObject(hTempRgn);
				}
			}
		}
		
		CombineRgn(hMainRgn, hMainRgn, hTransRgn, RGN_DIFF);
		SetWindowRgn(hwnd, hMainRgn, FALSE);

		DeleteDC(hdc);
		DeleteObject(hTransRgn);
		DeleteObject(hMainRgn);
	}
	else
	{
		RECT r;
		HRGN rgn;
		GetClientRect(hwnd, &r);
		rgn = CreateRectRgn(r.left, r.top, r.right, r.bottom);
		SetWindowRgn(hwnd, rgn, FALSE);
	}
}

void Unload()
{
	QUITTING=TRUE;

	while (start)
	{
		char temp[256] = "";
		struct Panel* p = start;
		start=p->next;

		while (p->buttons)
		{
			struct Button* b = p->buttons;
			p->buttons = b->next;
			if (TOOLTIPS) RemoveHint(b->hwnd);
			DestroyWindow(b->hwnd);
			DeleteObject(b->iconmask);
			DeleteObject(b->bg);
			DeleteObject(b->icon);
			DeleteObject(b->cbmp);
			DeleteObject(b->nbmp);
			DeleteObject(b->obmp);
			b->next = 0;
			b=NULL;
			free(b);
		}

		while (p->modules)
		{
			struct Module* m = p->modules;
			p->modules = m->next;
			if (m->QuitModule) m->QuitModule();
			FreeLibrary(m->dllInst);
			m->next = 0;
			m=NULL;
			free(m);
		}
	
		RemoveProp(p->hwnd, "PanelStruct");
		DestroyWindow(p->left);
		DestroyWindow(p->right);
		DestroyWindow(p->hwnd);
		DeleteObject(p->buttonbg);
		DeleteObject(p->bg);
		DeleteObject(p->cbg);
		DeleteObject(p->lbmp);
		DeleteObject(p->lobmp);
		DeleteObject(p->lcbmp);
		DeleteObject(p->rbmp);
		DeleteObject(p->robmp);
		DeleteObject(p->rcbmp);

		p=NULL;
		free(p);
	}

	start=0;
}

void ShowChildren(struct Panel* p, DWORD show)
{
	struct Panel* s;
	struct Button* b;
	struct Module* m;
	
	for (s=start; s; s=s->next)
	{
		if (IsChild(p->hwnd, s->hwnd))
		{
			ShowWindow(s->hwnd, show);
		}
	}

	for (b=p->buttons; b; b=b->next) ShowWindow(b->hwnd, show);
	for (m=p->modules; m; m=m->next) { if (m->ShowModuleWindow) { m->ShowModuleWindow(show); } }

	b=NULL;
	free(b);
	s=NULL;
	free(s);
}

void BrowseForFile(HWND hwnd, DWORD editbox, char* filter)
{
	char bmp[MAX_PATH] = "";
	OPENFILENAME* of	= malloc(sizeof(OPENFILENAME));

	of->lStructSize	= sizeof(OPENFILENAME);
	of->hwndOwner	= hwnd;
	of->hInstance	= NULL;
	of->lpstrFilter	= filter;
	of->lpstrCustomFilter = NULL;
	of->nMaxCustFilter	= 0;
	of->nFilterIndex	= 0;
	of->lpstrFile		= bmp;
	of->nMaxFile		= MAX_PATH;
	of->lpstrFileTitle	= NULL;
	of->lpstrInitialDir	= NULL;
	of->lpstrTitle		= "WinPanel - Browse for Image";
	of->Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_NOCHANGEDIR;

	__try 
	{ 
		if (GetOpenFileName(of)) SetDlgItemText(hwnd, editbox, bmp);
	}
	__except(1) { }

	free(of);
}

void BrowseForModule(HWND hwnd)
{
	char module[MAX_PATH] = "";
	OPENFILENAME* of	= malloc(sizeof(OPENFILENAME));

	of->lStructSize	= sizeof(OPENFILENAME);
	of->hwndOwner	= hwnd;
	of->hInstance	= NULL;
	of->lpstrFilter	= "WinPanel Module (*.dll)\0*.dll\0All Files (*.*)\0*.*\0\0";
	of->lpstrCustomFilter = NULL;
	of->nMaxCustFilter	= 0;
	of->nFilterIndex	= 0;
	of->lpstrFile		= module;
	of->nMaxFile		= MAX_PATH;
	of->lpstrFileTitle	= NULL;
	of->lpstrInitialDir	= NULL;
	of->lpstrTitle		= "WinPanel - Browse for Module";
	of->Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_NOCHANGEDIR;

	__try 
	{ 
		if (GetOpenFileName(of))
		{
			/*HWND lv = GetDlgItem(hwnd, IDC_MODULE_LIST);
			LVITEM item;
			int iItem = ListView_GetItemCount(lv);
			struct Module* m = (struct Module*)malloc(sizeof(struct Module));
			HPROPSHEETPAGE hpsp;
			PROPSHEETPAGE psp;

			m->dllInst = LoadLibrary(module);
			if (m->dllInst)
			{
				m->InitModule = (int (FAR*)(HINSTANCE, HWND, char*))GetProcAddress(m->dllInst, "InitModule");
				m->QuitModule = (void (FAR*)())GetProcAddress(m->dllInst, "QuitModule");
				m->ConfigProc = (DLGPROC (FAR*)(HWND, UINT, WPARAM, LPARAM))GetProcAddress(m->dllInst, "DialogConfigProc");
				m->QueryConfigId = (char* (FAR*)())GetProcAddress(m->dllInst, "QueryConfigId");
				m->QueryName = (char* (FAR*)())GetProcAddress(m->dllInst, "QueryName");
				m->ShowModuleWindow = (void (FAR*)(DWORD))GetProcAddress(m->dllInst, "ShowModuleWindow");

				if (m->InitModule && m->QuitModule)
				{
					item.mask = LVIF_TEXT;	
					item.iItem = iItem;
					item.iSubItem = 0;
					item.pszText = m->QueryName();
					ListView_InsertItem(lv, &item);

					item.iSubItem = 1;
					item.pszText = module;
					ListView_SetItem(lv, &item);

					psp.dwSize = sizeof(PROPSHEETPAGE);
					psp.dwFlags = PSP_USETITLE;
					psp.pszIcon = 0;
					psp.lParam = 0;
					psp.pfnCallback = NULL;
					psp.hInstance = m->dllInst;
					psp.pszTemplate = m->QueryConfigId();
					psp.pfnDlgProc = (DLGPROC)m->ConfigProc;
					psp.pszTitle = m->QueryName();
					
					hpsp = CreatePropertySheetPage(&psp);
					if (hpsp) PropSheet_AddPage(GetParent(hwnd), hpsp);
				}
				else
				{
					char error[256] = "";
					sprintf(error, "\"%s\" is not a valid WinPanel module.", module);
					MessageBox(hwnd, error, AppName, MB_SYSTEMMODAL | MB_ICONERROR);
				}
			}
			else
			{
				char error[256] = "";
				sprintf(error, "Unable to load module \"%s\".", module);
				MessageBox(hwnd, error, AppName, MB_SYSTEMMODAL | MB_ICONERROR);
			}
			m=NULL;
			free(m);*/
		}
	}
	__except(1) { }

	free(of);
}

void WPTransparentBlt(HDC hdc, int dx, int dy, int dw, int dh, HDC buf, int sx, int sy)
{
	HDC localDC, maskDC;
	HBITMAP localBMP, maskBMP;
	HBITMAP oldBMP, oldmaskBMP;

	maskDC = CreateCompatibleDC(buf);
	localDC = CreateCompatibleDC(buf);
	localBMP = CreateCompatibleBitmap(hdc, dw, dh);
	oldBMP = SelectObject(localDC, localBMP);
	BitBlt(localDC, 0, 0, dw, dh, buf, sx, sy, SRCCOPY);
	maskBMP = CreateBitmap(dw, dh, 1, 1, NULL);
	oldmaskBMP = SelectObject(maskDC, maskBMP);
	SetBkColor(localDC, 0x00FF00FF);
	BitBlt(maskDC, 0, 0, dw, dh, localDC, 0, 0, SRCCOPY);
	SetBkColor(localDC, 0x00000000);
	SetTextColor(localDC, 0x00FFFFFF);
	BitBlt(localDC, 0, 0, dw, dh, maskDC, 0, 0, SRCAND);
	SetBkColor(hdc, 0x00FFFFFF);
	SetTextColor(hdc, 0x00000000);
	BitBlt(hdc, dx, dy, dw, dh, maskDC, 0, 0, SRCAND);
	BitBlt(hdc, dx, dy, dw, dh, localDC, 0, 0, SRCPAINT);
	SelectObject(maskDC, oldmaskBMP);
	SelectObject(localDC, oldBMP);
	DeleteDC(maskDC);
	DeleteDC(localDC);
	DeleteObject(maskBMP);
	DeleteObject(localBMP);
	DeleteObject(oldBMP);
	DeleteObject(oldmaskBMP);
}

void CreateHint(HWND hwnd, char* text, RECT* r)
{
	TOOLINFO ti;
	static int id=0;
	char temp[256] = "";
	strcpy(temp, text);
	
	ti.cbSize = sizeof(TOOLINFO);
	ti.uFlags = 0;
	ti.hwnd = hwnd;
	ti.hinst = hinst;
	ti.uId = id++;
	ti.lpszText = temp;
	ti.rect.left = r->left;
	ti.rect.top  = r->top;
	ti.rect.right = r->right;
	ti.rect.bottom = r->bottom;

	SendMessage(ButtonHints, TTM_ADDTOOL, 0, (LPARAM) (LPTOOLINFO) &ti);
}

void RemoveHint(HWND hwnd) 
{
	TOOLINFO ti;
	RECT r={0,0,0,0};

	ti.cbSize = sizeof(TOOLINFO);
	ti.uFlags = 0;
	ti.hwnd = hwnd;
	ti.hinst = hinst;
	ti.uId = 0;
	ti.lpszText = NULL;
	ti.rect = r;

	SendMessage(ButtonHints, TTM_DELTOOL, 0, (LPARAM) (LPTOOLINFO) &ti);
}

void ButtonExecute(HWND hwnd, char* cmd)
{
	if (*cmd != '!') WinExec(cmd, SW_SHOWNORMAL);
	else
	{
		if (!_strnicmp(cmd, "!WinPanelConfig", 15))
		{
			DialogBox(hinst, MAKEINTRESOURCE(IDD_CONFIG), hwnd, ConfigProc);
		}
		else if (!_strnicmp(cmd, "!WinPanelQuit", 13))
		{
			if (CONFIRM_QUIT)
			{
				if (MessageBox(hwnd, "Are you sure you want to quit WinPanel?", "WinPanel Alert", MB_YESNO | MB_ICONQUESTION) == IDNO) return;
			}
			PostQuitMessage(0);
		}
		else if (!_strnicmp(cmd, "!WinPanelRecycle", 16))
		{
			Unload();
			LoadSetup();
		}
		else if (!_strnicmp(cmd, "!WinPanelCollapseLeft", 20))
		{
			PostMessage(hwnd, WP_COLLAPSE_LEFT, 0, 0);
		}
		else if (!_strnicmp(cmd, "!WinPanelCollapseRight", 21))
		{
			PostMessage(hwnd, WP_COLLAPSE_RIGHT, 0, 0);
		}
		else
		{
			UINT WP_MESSAGE = RegisterWindowMessage(cmd);
			struct Panel* p;

			for (p=start; p; p=p->next)
			{
				HWND find=NULL;
				while ((find = FindWindowEx(p->hwnd, find, NULL, NULL)) != NULL)
				{
					SendMessage(find, WP_MESSAGE, 0, 0);
				}
			}

			p=NULL;
			free(p);
		}
	}
}

BOOL CALLBACK ConfigProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg)
	{
		case WM_INITDIALOG:
		{
			HWND tv = GetDlgItem(hwnd, IDC_TREE);
			LoadPanelConfig(tv, "Main", NULL);
		}
		break;

		case WM_COMMAND:
		{
			switch (HIWORD(wParam))
			{
				case BN_CLICKED:
				{
					if (LOWORD(wParam) == IDOK) 
					{
						HWND tv = GetDlgItem(hwnd, IDC_TREE);
						HTREEITEM root = TreeView_GetRoot(tv), hti;
						int count=1;
						
						WritePrivateProfileSection("Main", NULL, cfgfile);

						hti = TreeView_GetNextItem(tv, root, TVGN_CHILD);
						while (hti)
						{
							TVITEMEX item;
							char panel[256] = "";
							char temp[256] = "";

							item.hItem = hti;
							item.mask = TVIF_TEXT;
							item.pszText = panel;
							item.cchTextMax = 256;

							TreeView_GetItem(tv, &item);

							sprintf(temp, "Panel%d", count++);
							WritePrivateProfileString("Main", temp, panel, cfgfile);

							SavePanelLayout(tv, hti, panel);

							hti = TreeView_GetNextSibling(tv, hti);
						}
						
						APPLY_CHANGES=TRUE; 
						EndDialog(hwnd, 0); 
						Unload(); 
						LoadSetup(); 
					}
					else if (LOWORD(wParam) == IDCANCEL) { APPLY_CHANGES=FALSE; EndDialog(hwnd, 0); }
				}
			}
		}
		break;

		case WM_NOTIFY:
		{
			LPNMHDR hdr = (LPNMHDR)lParam;

			if (hdr->idFrom == IDC_TREE)
			{
				if (hdr->code == TVN_SELCHANGING)
				{
					LPNMTREEVIEW tv = (LPNMTREEVIEW)lParam;
					ShowWindow((HWND)tv->itemOld.lParam, SW_HIDE);
					ShowWindow((HWND)tv->itemNew.lParam, SW_SHOW);
				}
				else if(hdr->code == TVN_BEGINLABELEDIT)
				{
					LPNMTVDISPINFO d = (LPNMTVDISPINFO)lParam;
					strcpy(labeledit, d->item.pszText);
				}
				else if (hdr->code == TVN_ENDLABELEDIT)
				{
					LPNMTVDISPINFO d = (LPNMTVDISPINFO)lParam;
					char temp[256] = "";
					TVITEMEX tvitem;

					if (!_stricmp(labeledit, "Main")
						|| !_stricmp(labeledit, "Buttons")
						|| !_stricmp(labeledit, "Configuration")
						|| !_stricmp(labeledit, "Modules")
						|| !_stricmp(labeledit, "Panels")
						|| !_stricmp(labeledit, "Left Button")
						|| !_stricmp(labeledit, "Right Button"))
					{
						memset(&labeledit, 0, sizeof(labeledit));
						break;
					}

					if (d)
					{
						if (d->item.pszText)
						{
							HWND find = FindWindowEx(hwnd, NULL, NULL, labeledit);

							strcpy(temp, d->item.pszText);
							tvitem.hItem = TreeView_GetSelection(hdr->hwndFrom);
							tvitem.pszText = temp;
							tvitem.cchTextMax = sizeof(temp);
							tvitem.mask = TVIF_TEXT;
							TreeView_SetItem(hdr->hwndFrom, &tvitem);

							while (find)
							{
								SetWindowText(find, d->item.pszText);
								find = FindWindowEx(hwnd, find, NULL, labeledit);
							}
						}
					}
					
					return TRUE;
				}
				else if (hdr->code == TVN_KEYDOWN)
				{
					LPNMTVKEYDOWN key = (LPNMTVKEYDOWN)lParam;
					
					if (key->wVKey == VK_DELETE)
					{
						HTREEITEM sel = TreeView_GetSelection(hdr->hwndFrom);
						char temp[256] = "";
						TVITEMEX tvitem;

						tvitem.hItem = sel;
						tvitem.pszText = temp;
						tvitem.cchTextMax = 256;
						tvitem.mask = TVIF_TEXT;
						TreeView_GetItem(hdr->hwndFrom, &tvitem);
						
						if (_stricmp(temp, "Main")
							&& _stricmp(temp, "Buttons")
							&& _stricmp(temp, "Configuration")
							&& _stricmp(temp, "Modules")
							&& _stricmp(temp, "Panels")
							&& _stricmp(temp, "Left Button")
							&& _stricmp(temp, "Right Button"))
						{
							char message[256] = "";
							sprintf(message, "Are you sure you want to delete \"%s\"?", temp);
							if (MessageBox(hwnd, message, AppName, MB_YESNO | MB_ICONQUESTION | MB_SYSTEMMODAL) == IDYES)
							{
								TreeView_DeleteItem(hdr->hwndFrom, sel);
								WritePrivateProfileSection(temp, NULL, cfgfile);
							}
						}
					}
				}
			}
		}
		break;
	}

	return FALSE;
}

void LoadPanelConfig(HWND tv, char* panel, HTREEITEM parent)
{
	TVINSERTSTRUCT tvi;
	TVITEMEX tvitem;
	char temp[256] = "";
	char child[256] = "";
	int x=1;
	int y=1;
	HWND hwnd;
	HTREEITEM buttonparent=NULL, moduleparent=NULL, configparent=NULL;

	if (strcmp(panel, "Main"))
	{
		SetDlgItemText(GetParent(tv), IDC_NAME, panel);
		
		// Main Panel
		hwnd = CreateDialog(hinst, MAKEINTRESOURCE(IDD_PANEL_MAIN), GetParent(tv), DialogPanelMainProc);
		tvitem.pszText = panel;
		tvitem.cchTextMax = sizeof(panel);
		tvitem.cChildren = 1;
		tvitem.lParam = (LPARAM)hwnd;
		tvitem.mask = TVIF_CHILDREN | TVIF_TEXT | TVIF_PARAM;
		tvi.hParent = parent;
		tvi.hInsertAfter = TVI_LAST;
		tvi.itemex = tvitem;
		parent = TreeView_InsertItem(tv, &tvi);

		// Configure
		hwnd = CreateDialog(hinst, MAKEINTRESOURCE(IDD_PANEL), GetParent(tv), DialogPanelProc);
		tvitem.pszText = "Configuration";
		tvitem.cchTextMax = 13;
		tvitem.cChildren=1;
		tvitem.lParam = (LPARAM)hwnd;
		tvitem.mask = TVIF_CHILDREN | TVIF_TEXT | TVIF_PARAM;
		tvi.hParent = parent;
		tvi.hInsertAfter = TVI_FIRST;
		tvi.itemex = tvitem;
		configparent = TreeView_InsertItem(tv, &tvi);

		// Left
		hwnd = CreateDialog(hinst, MAKEINTRESOURCE(IDD_PANEL_LEFT), GetParent(tv), DialogPanelLeftProc);
		tvitem.pszText = "Left Button";
		tvitem.cchTextMax = 11;
		tvitem.cChildren=0;
		tvitem.lParam = (LPARAM)hwnd;
		tvitem.mask = TVIF_CHILDREN | TVIF_TEXT | TVIF_PARAM;
		tvi.hParent = configparent;
		tvi.hInsertAfter = TVI_SORT;
		tvi.itemex = tvitem;
		TreeView_InsertItem(tv, &tvi);

		// Right
		hwnd = CreateDialog(hinst, MAKEINTRESOURCE(IDD_PANEL_RIGHT), GetParent(tv), DialogPanelRightProc);
		tvitem.pszText = "Right Button";
		tvitem.cchTextMax = 12;
		tvitem.cChildren=0;
		tvitem.lParam = (LPARAM)hwnd;
		tvitem.mask = TVIF_CHILDREN | TVIF_TEXT | TVIF_PARAM;
		tvi.hParent = configparent;
		tvi.hInsertAfter = TVI_SORT;
		tvi.itemex = tvitem;
		TreeView_InsertItem(tv, &tvi);

		// Buttons
		hwnd = CreateDialog(hinst, MAKEINTRESOURCE(IDD_BUTTON_MAIN), GetParent(tv), DialogButtonMainProc);
		tvitem.pszText = "Buttons";
		tvitem.cchTextMax = 7;
		tvitem.cChildren=0;
		tvitem.lParam = (LPARAM)hwnd;
		tvitem.mask = TVIF_CHILDREN | TVIF_TEXT | TVIF_PARAM;
		tvi.hParent = parent;
		tvi.hInsertAfter = TVI_SORT;
		tvi.itemex = tvitem;
		buttonparent = TreeView_InsertItem(tv, &tvi);

		// Modules
		tvitem.pszText = "Modules";
		tvitem.cchTextMax = 7;
		tvitem.cChildren=0;
		tvitem.mask = TVIF_CHILDREN | TVIF_TEXT;
		tvi.hParent = parent;
		tvi.hInsertAfter = TVI_SORT;
		tvi.itemex = tvitem;
		moduleparent = TreeView_InsertItem(tv, &tvi);

		// Panels
		tvitem.pszText = "Panels";
		tvitem.cchTextMax = 6;
		tvitem.cChildren=0;
		tvitem.mask = TVIF_CHILDREN | TVIF_TEXT;
		tvi.hParent = parent;
		tvi.hInsertAfter = TVI_SORT;
		tvi.itemex = tvitem;
		parent = TreeView_InsertItem(tv, &tvi);
	}
	else
	{
		// Main
		hwnd = CreateDialog(hinst, MAKEINTRESOURCE(IDD_MAIN), GetParent(tv), DialogMainProc);
		tvitem.pszText = panel;
		tvitem.cchTextMax = sizeof(panel);
		tvitem.cChildren = 0;
		tvitem.lParam = (LPARAM)hwnd;
		tvitem.mask = TVIF_CHILDREN | TVIF_TEXT | TVIF_PARAM;

		tvi.hParent = parent;
		tvi.hInsertAfter = TVI_LAST;
		tvi.itemex = tvitem;
		parent = TreeView_InsertItem(tv, &tvi);
	
	}
	
	sprintf(temp, "Panel%d", y++);
	GetPrivateProfileString(panel, temp, "no more honky", child, 256, cfgfile);
	while (strcmp(child, "no more honky"))
	{
		TVITEMEX update;
		update.hItem = parent;
		update.cChildren=1;
		update.mask = TVIF_CHILDREN;
		TreeView_SetItem(tv, &update);

		LoadPanelConfig(tv, child, parent);
		sprintf(temp, "Panel%d", y++);
		GetPrivateProfileString(panel, temp, "no more honky", child, 256, cfgfile);
	}
	
	y=1;
	sprintf(temp, "Button%d", y++);
	GetPrivateProfileString(panel, temp, "no more honky", child, 256, cfgfile);
	while (strcmp(child, "no more honky"))
	{
		TVINSERTSTRUCT ctvi;
		TVITEMEX ctvitem;
		TVITEMEX update;
		
		update.hItem = buttonparent;
		update.cChildren=1;
		update.mask = TVIF_CHILDREN;
		TreeView_SetItem(tv, &update);

		SetDlgItemText(GetParent(tv), IDC_NAME, child);
		hwnd = CreateDialog(hinst, MAKEINTRESOURCE(IDD_BUTTON), GetParent(tv), DialogButtonProc);

		ctvitem.pszText = child;
		ctvitem.cchTextMax = sizeof(child);
		ctvitem.cChildren = 0;
		ctvitem.lParam = (LPARAM)hwnd;
		ctvitem.mask = TVIF_CHILDREN | TVIF_TEXT | TVIF_PARAM;
		ctvi.hParent = buttonparent;
		ctvi.hInsertAfter = TVI_LAST;
		ctvi.itemex = ctvitem;
		TreeView_InsertItem(tv, &ctvi);
		
		sprintf(temp, "Button%d", y++);
		GetPrivateProfileString(panel, temp, "no more honky", child, 256, cfgfile);
	}

	y=1;
	sprintf(temp, "Module%d", y++);
	GetPrivateProfileString(panel, temp, "no more honky", child, 256, cfgfile);
	while (strcmp(child, "no more honky"))
	{
		TVITEMEX update;
		
		update.hItem = moduleparent;
		update.cChildren=1;
		update.mask = TVIF_CHILDREN;
		TreeView_SetItem(tv, &update);

		tvitem.pszText = child;
		tvitem.cchTextMax = sizeof(child);
		tvitem.cChildren = 0;
		tvi.hParent = moduleparent;
		tvi.hInsertAfter = TVI_LAST;
		tvi.itemex = tvitem;
		TreeView_InsertItem(tv, &tvi);
		
		sprintf(temp, "Module%d", y++);
		GetPrivateProfileString(panel, temp, "no more honky", child, 256, cfgfile);
	}
}

BOOL CALLBACK DialogPanelMainProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg)
	{
		case WM_COMMAND:
		{
			switch (HIWORD(wParam))
			{
				case BN_CLICKED:
				{
					switch (LOWORD(wParam))
					{
						case IDC_DELETE_PANEL:
						{
							HWND tv = GetDlgItem(GetParent(hwnd), IDC_TREE);
							HTREEITEM sel = TreeView_GetSelection(tv);
							char temp[256] = "";
							char message[256] = "";
							TVITEMEX tvitem;

							tvitem.hItem = sel;
							tvitem.pszText = temp;
							tvitem.cchTextMax = 256;
							tvitem.mask = TVIF_TEXT;
							TreeView_GetItem(tv, &tvitem);
							
							sprintf(message, "Are you sure you want to delete \"%s\"?", temp);
							if (MessageBox(hwnd, message, AppName, MB_YESNO | MB_ICONQUESTION | MB_SYSTEMMODAL) == IDYES)
							{
								TreeView_SelectItem(tv, TreeView_GetNextSibling(tv, sel));	
								TreeView_DeleteItem(tv, sel);
								WritePrivateProfileSection(temp, NULL, cfgfile);
								APPLY_CHANGES=FALSE;
								EndDialog(hwnd, 0);
								DestroyWindow(hwnd);
							}

						}
						break;
					}
				}
				break;
			}
		}
		break;
	}

	return FALSE;
}

BOOL CALLBACK DialogPanelProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg)
	{
		case WM_INITDIALOG:
		{
			char panel[256] = "";
			char temp[256] = "";
			int tval=0;
			GetDlgItemText(GetParent(hwnd), IDC_NAME, panel, 256);

			SetDlgItemText(hwnd, IDC_PANEL_NAME, panel);
			SetWindowText(hwnd, panel);

			GetPrivateProfileString(panel, "X", "0", temp, 256, cfgfile);
			SetDlgItemText(hwnd, IDC_X, temp);
			GetPrivateProfileString(panel, "Y", "0", temp, 256, cfgfile);
			SetDlgItemText(hwnd, IDC_Y, temp);
			GetPrivateProfileString(panel, "W", "0", temp, 256, cfgfile);
			SetDlgItemText(hwnd, IDC_W, temp);
			GetPrivateProfileString(panel, "H", "0", temp, 256, cfgfile);
			SetDlgItemText(hwnd, IDC_H, temp);

			GetPrivateProfileString(panel, "Open", "", temp, 256, cfgfile);
			SetDlgItemText(hwnd, IDC_OPEN, temp);
			GetPrivateProfileString(panel, "Closed", "", temp, 256, cfgfile);
			SetDlgItemText(hwnd, IDC_CLOSED, temp);

			tval = GetPrivateProfileInt(panel, "OnAllDesktops", 0, cfgfile);
			if (tval) SendDlgItemMessage(hwnd, IDC_ON_ALL_DESKTOPS, BM_SETCHECK, BST_CHECKED, 0);
			tval = GetPrivateProfileInt(panel, "AlwaysOnTop", 0, cfgfile);
			if (tval) SendDlgItemMessage(hwnd, IDC_ALWAYS_ON_TOP, BM_SETCHECK, BST_CHECKED, 0);
		}
		break;

		case WM_DESTROY:
		{
			if (APPLY_CHANGES)
			{
				char oldpanel[256] = "";
				char panel[256] = "";
				char temp[256] = "";
				int tval=0;

				GetDlgItemText(hwnd, IDC_PANEL_NAME, oldpanel, 256);
				GetWindowText(hwnd, panel, 256);

				if (_stricmp(panel, oldpanel)) WritePrivateProfileSection(oldpanel, NULL, cfgfile);
				
				GetDlgItemText(hwnd, IDC_X, temp, 256);
				WritePrivateProfileString(panel, "X", temp, cfgfile);
				GetDlgItemText(hwnd, IDC_Y, temp, 256);
				WritePrivateProfileString(panel, "Y", temp, cfgfile);
				GetDlgItemText(hwnd, IDC_W, temp, 256);
				WritePrivateProfileString(panel, "W", temp, cfgfile);
				GetDlgItemText(hwnd, IDC_H, temp, 256);
				WritePrivateProfileString(panel, "H", temp, cfgfile);

				GetDlgItemText(hwnd, IDC_OPEN, temp, 256);
				WritePrivateProfileString(panel, "Open", temp, cfgfile);
				GetDlgItemText(hwnd, IDC_CLOSED, temp, 256);
				WritePrivateProfileString(panel, "Closed", temp, cfgfile);

				tval = SendDlgItemMessage(hwnd, IDC_ON_ALL_DESKTOPS, BM_GETCHECK, 0, 0);
				sprintf(temp, "%d", tval);
				WritePrivateProfileString(panel, "OnAllDesktops", temp, cfgfile);
				tval = SendDlgItemMessage(hwnd, IDC_ALWAYS_ON_TOP, BM_GETCHECK, 0, 0);
				sprintf(temp, "%d", tval);
				WritePrivateProfileString(panel, "AlwaysOnTop", temp, cfgfile);
			}
		}
		break;
	}

	return FALSE;
}

BOOL CALLBACK DialogPanelLeftProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg)
	{
		case WM_INITDIALOG:
		{
			char panel[256] = "";
			char temp[256] = "";
			GetDlgItemText(GetParent(hwnd), IDC_NAME, panel, 256);
			
			SetWindowText(hwnd, panel);

			GetPrivateProfileString(panel, "LeftX", "0", temp, 256, cfgfile);
			SetDlgItemText(hwnd, IDC_LEFT_X, temp);
			GetPrivateProfileString(panel, "LeftY", "0", temp, 256, cfgfile);
			SetDlgItemText(hwnd, IDC_LEFT_Y, temp);
			GetPrivateProfileString(panel, "Left", "", temp, 256, cfgfile);
			SetDlgItemText(hwnd, IDC_LEFT_NORMAL, temp);
			GetPrivateProfileString(panel, "LeftOver", "", temp, 256, cfgfile);
			SetDlgItemText(hwnd, IDC_LEFT_OVER, temp);
			GetPrivateProfileString(panel, "LeftClick", "", temp, 256, cfgfile);
			SetDlgItemText(hwnd, IDC_LEFT_CLICK, temp);
		}
		break;

		case WM_DESTROY:
		{
			if (APPLY_CHANGES)
			{
				char panel[256] = "";
				char temp[256] = "";

				GetWindowText(hwnd, panel, 256);

				GetDlgItemText(hwnd, IDC_LEFT_X, temp, 256);
				WritePrivateProfileString(panel, "LeftX", temp, cfgfile);
				GetDlgItemText(hwnd, IDC_LEFT_Y, temp, 256);
				WritePrivateProfileString(panel, "LeftY", temp, cfgfile);
				GetDlgItemText(hwnd, IDC_LEFT_NORMAL, temp, 256);
				WritePrivateProfileString(panel, "Left", temp, cfgfile);
				GetDlgItemText(hwnd, IDC_LEFT_OVER, temp, 256);
				WritePrivateProfileString(panel, "LeftOver", temp, cfgfile);
				GetDlgItemText(hwnd, IDC_LEFT_CLICK, temp, 256);
				WritePrivateProfileString(panel, "LeftClick", temp, cfgfile);
			}
		}
		break;
	}

	return FALSE;
}

BOOL CALLBACK DialogPanelRightProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg)
	{
		case WM_INITDIALOG:
		{
			char panel[256] = "";
			char temp[256] = "";
			GetDlgItemText(GetParent(hwnd), IDC_NAME, panel, 256);
			
			SetWindowText(hwnd, panel);

			GetPrivateProfileString(panel, "RightX", "0", temp, 256, cfgfile);
			SetDlgItemText(hwnd, IDC_RIGHT_X, temp);
			GetPrivateProfileString(panel, "RightY", "0", temp, 256, cfgfile);
			SetDlgItemText(hwnd, IDC_RIGHT_Y, temp);
			GetPrivateProfileString(panel, "Right", "", temp, 256, cfgfile);
			SetDlgItemText(hwnd, IDC_RIGHT_NORMAL, temp);
			GetPrivateProfileString(panel, "RightOver", "", temp, 256, cfgfile);
			SetDlgItemText(hwnd, IDC_RIGHT_OVER, temp);
			GetPrivateProfileString(panel, "RightClick", "", temp, 256, cfgfile);
			SetDlgItemText(hwnd, IDC_RIGHT_CLICK, temp);
		}
		break;

		case WM_DESTROY:
		{
			if (APPLY_CHANGES)
			{
				char panel[256] = "";
				char temp[256] = "";

				GetWindowText(hwnd, panel, 256);

				GetDlgItemText(hwnd, IDC_RIGHT_X, temp, 256);
				WritePrivateProfileString(panel, "RightX", temp, cfgfile);
				GetDlgItemText(hwnd, IDC_RIGHT_Y, temp, 256);
				WritePrivateProfileString(panel, "RightY", temp, cfgfile);
				GetDlgItemText(hwnd, IDC_RIGHT_NORMAL, temp, 256);
				WritePrivateProfileString(panel, "Right", temp, cfgfile);
				GetDlgItemText(hwnd, IDC_RIGHT_OVER, temp, 256);
				WritePrivateProfileString(panel, "RightOver", temp, cfgfile);
				GetDlgItemText(hwnd, IDC_RIGHT_CLICK, temp, 256);
				WritePrivateProfileString(panel, "RightClick", temp, cfgfile);
			}
		}
		break;
	}

	return FALSE;
}


BOOL CALLBACK DialogButtonProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg)
	{
		case WM_INITDIALOG:
		{
			char button[256] = "";
			char temp[256] = "";
			GetDlgItemText(GetParent(hwnd), IDC_NAME, button, 256);

			SetDlgItemText(hwnd, IDC_BUTTON_NAME, button);
			SetWindowText(hwnd, button);

			GetPrivateProfileString(button, "X", "0", temp, 256, cfgfile);
			SetDlgItemText(hwnd, IDC_BUTTON_X, temp);
			GetPrivateProfileString(button, "Y", "0", temp, 256, cfgfile);
			SetDlgItemText(hwnd, IDC_BUTTON_Y, temp);
			GetPrivateProfileString(button, "W", "0", temp, 256, cfgfile);
			SetDlgItemText(hwnd, IDC_BUTTON_W, temp);
			GetPrivateProfileString(button, "H", "0", temp, 256, cfgfile);
			SetDlgItemText(hwnd, IDC_BUTTON_H, temp);

			GetPrivateProfileString(button, "Background", "", temp, 256, cfgfile);
			SetDlgItemText(hwnd, IDC_BUTTON_BACKGROUND, temp);
			GetPrivateProfileString(button, "Normal", "", temp, 256, cfgfile);
			SetDlgItemText(hwnd, IDC_BUTTON_NORMAL, temp);
			GetPrivateProfileString(button, "Over", "", temp, 256, cfgfile);
			SetDlgItemText(hwnd, IDC_BUTTON_OVER, temp);
			GetPrivateProfileString(button, "Click", "", temp, 256, cfgfile);
			SetDlgItemText(hwnd, IDC_BUTTON_CLICK, temp);
			GetPrivateProfileString(button, "Execute", "", temp, 256, cfgfile);
			SetDlgItemText(hwnd, IDC_BUTTON_EXECUTE, temp);
		}
		break;

		case WM_DESTROY:
		{
			if (APPLY_CHANGES)
			{
				char button[256] = "";
				char temp[256] = "";

				GetDlgItemText(hwnd, IDC_BUTTON_NAME, button, 256);
				WritePrivateProfileSection(button, NULL, cfgfile);
				GetWindowText(hwnd, button, 256);
				WritePrivateProfileSection(button, NULL, cfgfile);

				GetDlgItemText(hwnd, IDC_BUTTON_X, temp, 256);
				WritePrivateProfileString(button, "X", temp, cfgfile);
				GetDlgItemText(hwnd, IDC_BUTTON_Y, temp, 256);
				WritePrivateProfileString(button, "Y", temp, cfgfile);
				GetDlgItemText(hwnd, IDC_BUTTON_W, temp, 256);
				WritePrivateProfileString(button, "W", temp, cfgfile);
				GetDlgItemText(hwnd, IDC_BUTTON_H, temp, 256);
				WritePrivateProfileString(button, "H", temp, cfgfile);

				GetDlgItemText(hwnd, IDC_BUTTON_BACKGROUND, temp, 256);
				WritePrivateProfileString(button, "Background", temp, cfgfile);
				GetDlgItemText(hwnd, IDC_BUTTON_NORMAL, temp, 256);
				WritePrivateProfileString(button, "Normal", temp, cfgfile);
				GetDlgItemText(hwnd, IDC_BUTTON_OVER, temp, 256);
				WritePrivateProfileString(button, "Over", temp, cfgfile);
				GetDlgItemText(hwnd, IDC_BUTTON_CLICK, temp, 256);
				WritePrivateProfileString(button, "Click", temp, cfgfile);
				GetDlgItemText(hwnd, IDC_BUTTON_EXECUTE, temp, 256);
				WritePrivateProfileString(button, "Execute", temp, cfgfile);
			}
		}
		break;

		case WM_COMMAND:
		{
			switch (HIWORD(wParam))
			{
				case BN_CLICKED:
				{
					switch (LOWORD(wParam))
					{
						case IDC_DELETE_BUTTON:
						{
							HWND tv = GetDlgItem(GetParent(hwnd), IDC_TREE);
							HTREEITEM sel = TreeView_GetSelection(tv);
							char temp[256] = "";
							char message[256] = "";
							TVITEMEX tvitem;

							tvitem.hItem = sel;
							tvitem.pszText = temp;
							tvitem.cchTextMax = 256;
							tvitem.mask = TVIF_TEXT;
							TreeView_GetItem(tv, &tvitem);
							
							sprintf(message, "Are you sure you want to delete \"%s\"?", temp);
							if (MessageBox(hwnd, message, AppName, MB_YESNO | MB_ICONQUESTION | MB_SYSTEMMODAL) == IDYES)
							{
								TreeView_SelectItem(tv, TreeView_GetNextSibling(tv, sel));	
								TreeView_DeleteItem(tv, sel);
								WritePrivateProfileSection(temp, NULL, cfgfile);
								APPLY_CHANGES=FALSE;
								EndDialog(hwnd, 0);
								DestroyWindow(hwnd);
							}
						}
						break;
					}
				}
				break;
			}
		}
		break;
	}

	return FALSE;
}

BOOL CALLBACK DialogButtonMainProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg)
	{
		case WM_COMMAND:
		{
			switch (HIWORD(wParam))
			{
				case BN_CLICKED:
				{
					switch (LOWORD(wParam))
					{
						case IDC_ADD_BUTTON:
						{
							HWND tv = GetDlgItem(GetParent(hwnd), IDC_TREE);
							HTREEITEM sel = TreeView_GetSelection(tv);
							TVITEMEX update;
							TVINSERTSTRUCT ctvi;
							TVITEMEX ctvitem;
							
							update.hItem = sel;
							update.cChildren=1;
							update.mask = TVIF_CHILDREN;
							TreeView_SetItem(tv, &update);

							SetDlgItemText(GetParent(tv), IDC_NAME, "New Button");
							hwnd = CreateDialog(hinst, MAKEINTRESOURCE(IDD_BUTTON), GetParent(tv), DialogButtonProc);

							ctvitem.pszText = "New Button";
							ctvitem.cchTextMax = sizeof("New Button");
							ctvitem.cChildren = 0;
							ctvitem.lParam = (LPARAM)hwnd;
							ctvitem.mask = TVIF_CHILDREN | TVIF_TEXT | TVIF_PARAM;
							ctvi.hParent = sel;
							ctvi.hInsertAfter = TVI_LAST;
							ctvi.itemex = ctvitem;
							TreeView_InsertItem(tv, &ctvi);		
						}
						break;
					}
				}
				break;
			}
		}
		break;
	}

	return FALSE;
}

BOOL CALLBACK DialogMainProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg)
	{
		case WM_INITDIALOG:
		{
			int tval=0;
			char temp[256] = "";

			SetDlgItemText(hwnd, IDC_IMAGE_DIRECTORY, IMAGE_DIR);
			tval = GetPrivateProfileInt("Main", "ConfirmQuit", 1, cfgfile);
			if (tval) SendDlgItemMessage(hwnd, IDC_CONFIRM_QUIT, BM_SETCHECK, BST_CHECKED, 0);
			tval = GetPrivateProfileInt("Main", "HideExplorerDesktop", 0, cfgfile);
			if (tval) SendDlgItemMessage(hwnd, IDC_HIDE_EXPLORER_DESKTOP, BM_SETCHECK, BST_CHECKED, 0);
			tval = GetPrivateProfileInt("Main", "HideExplorerTaskbar", 0, cfgfile);
			if (tval) SendDlgItemMessage(hwnd, IDC_HIDE_EXPLORER_TASKBAR, BM_SETCHECK, BST_CHECKED, 0);

			GetPrivateProfileString("Main", "DesktopTop", "0", temp, 256, cfgfile);
			SetDlgItemText(hwnd, IDC_DESKTOP_TOP, temp);
			GetPrivateProfileString("Main", "DesktopLeft", "0", temp, 256, cfgfile);
			SetDlgItemText(hwnd, IDC_DESKTOP_LEFT, temp);
			GetPrivateProfileString("Main", "DesktopBottom", "0", temp, 256, cfgfile);
			SetDlgItemText(hwnd, IDC_DESKTOP_BOTTOM, temp);
			GetPrivateProfileString("Main", "DesktopRight", "0", temp, 256, cfgfile);
			SetDlgItemText(hwnd, IDC_DESKTOP_RIGHT, temp);
		}
		break;

		case WM_DESTROY:
		{
			if (APPLY_CHANGES)
			{
				char temp[256] = "";
				int tval=0;

				GetDlgItemText(hwnd, IDC_IMAGE_DIRECTORY, temp, 256);
				WritePrivateProfileString("Main", "ImageDirectory", temp, cfgfile);
				tval = SendDlgItemMessage(hwnd, IDC_CONFIRM_QUIT, BM_GETCHECK, 0, 0);
				sprintf(temp, "%d", tval);
				WritePrivateProfileString("Main", "ConfirmQuit", temp, cfgfile);
				tval = SendDlgItemMessage(hwnd, IDC_HIDE_EXPLORER_DESKTOP, BM_GETCHECK, 0, 0);
				sprintf(temp, "%d", tval);
				WritePrivateProfileString("Main", "HideExplorerDesktop", temp, cfgfile);
				tval = SendDlgItemMessage(hwnd, IDC_HIDE_EXPLORER_TASKBAR, BM_GETCHECK, 0, 0);
				sprintf(temp, "%d", tval);
				WritePrivateProfileString("Main", "HideExplorerTaskbar", temp, cfgfile);

				GetDlgItemText(hwnd, IDC_DESKTOP_TOP, temp, 256);
				WritePrivateProfileString("Main", "DesktopTop", temp, cfgfile);
				GetDlgItemText(hwnd, IDC_DESKTOP_LEFT, temp, 256);
				WritePrivateProfileString("Main", "DesktopLeft", temp, cfgfile);
				GetDlgItemText(hwnd, IDC_DESKTOP_BOTTOM, temp, 256);
				WritePrivateProfileString("Main", "DesktopBottom", temp, cfgfile);
				GetDlgItemText(hwnd, IDC_DESKTOP_RIGHT, temp, 256);
				WritePrivateProfileString("Main", "DesktopRight", temp, cfgfile);
			}
		}
		break;

		case WM_COMMAND:
		{
			switch (HIWORD(wParam))
			{
				case BN_CLICKED:
				{
					switch (LOWORD(wParam))
					{
						case IDC_MAIN_ADD_PANEL:
						{
							HWND tv = GetDlgItem(GetParent(hwnd), IDC_TREE);
							LoadPanelConfig(tv, "New Panel", TreeView_GetRoot(tv));
						}
						break;
					}
				}
			}
		}
		break;
	}

	return FALSE;
}

void SavePanelLayout(HWND tv, HTREEITEM hti, char* panel)
{
	HTREEITEM child = TreeView_GetNextItem(tv, hti, TVGN_CHILD);

	WritePrivateProfileSection(panel, NULL, cfgfile);

	while (child)
	{
		TVITEMEX item;
		char temp[256] = "";
		
		item.hItem = child;
		item.mask = TVIF_TEXT;
		item.pszText = temp;
		item.cchTextMax = 256;
		
		TreeView_GetItem(tv, &item);
	
		if (!_stricmp(temp, "Buttons"))
		{
			HTREEITEM button = TreeView_GetNextItem(tv, child, TVGN_CHILD);
			int count=1;

			while (button)
			{
				TVITEMEX item;
				char text[256] = "";

				item.hItem = button;
				item.mask = TVIF_TEXT;
				item.pszText = text;
				item.cchTextMax = 256;				
				TreeView_GetItem(tv, &item);
				
				sprintf(temp, "Button%d", count++);
				WritePrivateProfileString(panel, temp, text, cfgfile);

				button = TreeView_GetNextSibling(tv, button);
			}
		}
		else if (!_stricmp(temp, "Modules"))
		{
			HTREEITEM module = TreeView_GetNextItem(tv, child, TVGN_CHILD);
			int count=1;

			while (module)
			{
				TVITEMEX item;
				char text[256] = "";

				item.hItem = module;
				item.mask = TVIF_TEXT;
				item.pszText = text;
				item.cchTextMax = 256;				
				TreeView_GetItem(tv, &item);
				
				sprintf(temp, "Module%d", count++);
				WritePrivateProfileString(panel, temp, text, cfgfile);

				module = TreeView_GetNextSibling(tv, module);
			}
		}
		else if (!_stricmp(temp, "Panels"))
		{
			HTREEITEM childpanel = TreeView_GetNextItem(tv, child, TVGN_CHILD);
			int count=1;

			while (childpanel)
			{
				TVITEMEX item;
				char text[256] = "";

				item.hItem = childpanel;
				item.mask = TVIF_TEXT;
				item.pszText = text;
				item.cchTextMax = 256;				
				TreeView_GetItem(tv, &item);
				
				sprintf(temp, "Panel%d", count++);
				WritePrivateProfileString(panel, temp, text, cfgfile);

				SavePanelLayout(tv, childpanel, text);

				childpanel = TreeView_GetNextSibling(tv, childpanel);
			}
		}
		
		child = TreeView_GetNextSibling(tv, child);
	}
}