#include <windows.h>
#include <stdio.h>
#include <time.h>
#include <math.h>
//#include "resource.h"

__declspec( dllexport ) int InitModule(HINSTANCE hInstance, HWND parent, char* config);
__declspec( dllexport ) void QuitModule();
__declspec( dllexport ) DLGPROC DialogConfigProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
__declspec( dllexport ) char* QueryConfigId();
__declspec( dllexport ) char* QueryName();
__declspec( dllexport ) void ShowModuleWindow(DWORD show);

LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);

void LoadSetup();

HINSTANCE hinst=NULL;
HWND parent=NULL;
HWND hwndMain=NULL;
char cfgfile[MAX_PATH] = "";
char* szAppName = "WPClock";
int X, Y, W, H;
char IMAGE_DIR[MAX_PATH] = "";
HBITMAP TEXT_IMAGE=NULL, BG_IMAGE=NULL;
int NUM_WIDTH, NUM_HEIGHT, LET_WIDTH, LET_HEIGHT;
int TX, TY, WDX, WDY, DX, DY, MX, MY, CLX, CLY, HL, ML, AMPMX, AMPMY, CR, SHR;
int SecondHandMode;
HPEN HourHandPen, MinuteHandPen, SecondHandPen;
BOOL ANALOG, DIGITAL;

int InitModule(HINSTANCE hInstance, HWND Parent, char* config)
{
	WNDCLASS wc;

	// Save all incoming settings
	hinst = hInstance;
	parent = Parent;
	strcpy(cfgfile, config);

	if (parent)
	{
		memset(&wc,0,sizeof(wc));
		wc.hInstance = hInstance;
		wc.lpfnWndProc = WndProc;
		wc.lpszClassName = szAppName;
		wc.hCursor = LoadCursor(NULL, IDC_ARROW);
		RegisterClass(&wc);
	}

	LoadSetup();

	hwndMain = CreateWindow(szAppName, szAppName, WS_VISIBLE | WS_CHILD, X, Y, W, H, parent, NULL, hinst, 0);
	if (!hwndMain) return 0;

	SetTimer(hwndMain, 0, 950, NULL);

	return 1;
}

void QuitModule()
{
	// Unregister windows classes etc...
	KillTimer(hwndMain, 0);
	DeleteObject(TEXT_IMAGE);
	DeleteObject(BG_IMAGE);
	DeleteObject(HourHandPen);
	DeleteObject(MinuteHandPen);
	DeleteObject(SecondHandPen);
	DestroyWindow(hwndMain);
	UnregisterClass(szAppName, hinst);
}

char* QueryConfigId() { return NULL; } // MAKEINTRESOURCE(IDD_CONFIG); }
char* QueryName() { return szAppName; }
void ShowModuleWindow(DWORD show) 
{
	ShowWindow(hwndMain, show);
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg)
	{
		case WM_PAINT:
		{
			PAINTSTRUCT ps;
			HDC hdc = BeginPaint(hwnd, &ps);
			HDC buf = CreateCompatibleDC(NULL);
			HDC src = CreateCompatibleDC(NULL);
			HBITMAP bufbmp = CreateCompatibleBitmap(hdc, W, H), oldbufbmp, oldsrcbmp;
			HPEN oldpen;
			struct tm *newtime;
			char am_pm[] = "AM";
			time_t long_time;
			char temp[256] = "";
			char day[4] = "";
			char mon[4] = "";
			double x,y;
			double pi = 3.1415926535;
			int hour;

			time( &long_time );
			newtime = localtime( &long_time );
			if( newtime->tm_hour > 12 ) 
			{
				strcpy( am_pm, "PM" );
				newtime->tm_hour -= 12;
			}
			if( newtime->tm_hour == 0 ) newtime->tm_hour = 12;
			
			strcpy(temp, asctime(newtime));
			strncpy(day, temp, 3);
			strncpy(mon, temp+4, 3);
			hour = newtime->tm_hour;
			
			oldbufbmp = SelectObject(buf, bufbmp);
			oldsrcbmp = SelectObject(src, BG_IMAGE);
			BitBlt(buf, 0, 0, W, H, src, 0, 0, SRCCOPY);
			SelectObject(src, oldsrcbmp);

			if (DIGITAL)
			{
				oldsrcbmp = SelectObject(src, TEXT_IMAGE);

				// Week Day
				BitBlt(buf, WDX, WDY, LET_WIDTH, LET_HEIGHT, src, (int)(day[0] - 65) * LET_WIDTH, LET_HEIGHT, SRCCOPY);
				BitBlt(buf, WDX + LET_WIDTH, WDY, LET_WIDTH, LET_HEIGHT, src, (int)(day[1] - 97) * LET_WIDTH, 0, SRCCOPY);
				BitBlt(buf, WDX + LET_WIDTH*2, WDY, LET_WIDTH, LET_HEIGHT, src, (int)(day[2] - 97) * LET_WIDTH, 0, SRCCOPY);

				// Month
				BitBlt(buf, MX, MY, LET_WIDTH, LET_HEIGHT, src, (int)(mon[0] - 65) * LET_WIDTH, LET_HEIGHT, SRCCOPY);
				BitBlt(buf, MX + LET_WIDTH, MY, LET_WIDTH, LET_HEIGHT, src, (int)(mon[1] - 97) * LET_WIDTH, 0, SRCCOPY);
				BitBlt(buf, MX + LET_WIDTH*2, MY, LET_WIDTH, LET_HEIGHT, src, (int)(mon[2] - 97) * LET_WIDTH, 0, SRCCOPY);

				// Date
				if (newtime->tm_mday >= 10) BitBlt(buf, DX, DY, LET_WIDTH, LET_HEIGHT, src, newtime->tm_mday / 10 * LET_WIDTH, LET_HEIGHT*2, SRCCOPY);
				BitBlt(buf, DX + LET_WIDTH, DY, LET_WIDTH, LET_HEIGHT, src, newtime->tm_mday % 10 * LET_WIDTH, LET_HEIGHT*2, SRCCOPY);

				// Hour
				if (newtime->tm_hour >= 10) 
				{
					BitBlt(buf, TX, TY, LET_WIDTH, LET_HEIGHT, src, LET_WIDTH, LET_HEIGHT*2, SRCCOPY);
					newtime->tm_hour -= 10;
				}
				BitBlt(buf, TX + LET_WIDTH, TY, LET_WIDTH, LET_HEIGHT, src, newtime->tm_hour * LET_WIDTH, LET_HEIGHT*2, SRCCOPY);

				// Colon
				BitBlt(buf, TX + LET_WIDTH*2, TY, LET_WIDTH, LET_HEIGHT, src, 11 * LET_WIDTH, LET_HEIGHT*2, SRCCOPY);

				// Minute
				BitBlt(buf, TX + LET_WIDTH*3, TY, LET_WIDTH, LET_HEIGHT, src, newtime->tm_min / 10 * LET_WIDTH, LET_HEIGHT*2, SRCCOPY);
				BitBlt(buf, TX + LET_WIDTH*4, TY, LET_WIDTH, LET_HEIGHT, src, newtime->tm_min % 10 * LET_WIDTH, LET_HEIGHT*2, SRCCOPY);

				// AM/PM
				BitBlt(buf, AMPMX, AMPMY, LET_WIDTH, LET_HEIGHT, src, (int)(am_pm[0]-65) * LET_WIDTH, LET_HEIGHT, SRCCOPY);
				BitBlt(buf, AMPMX + LET_WIDTH, AMPMY, LET_WIDTH, LET_HEIGHT, src, (int)(am_pm[1]-65) * LET_WIDTH, LET_HEIGHT, SRCCOPY);
			}

			if (ANALOG)
			{
				// Clock hands
				oldpen = SelectObject(buf, HourHandPen);
				MoveToEx(buf, CLX, CLY, NULL);
				x = HL * sin((hour * pi/6) + (newtime->tm_min * pi/360));
				y = HL * cos((hour * pi/6) + (newtime->tm_min * pi/360));
				LineTo(buf, CLX + (int)x, CLY - (int)y);
				SelectObject(buf, oldpen);

				oldpen = SelectObject(buf, MinuteHandPen);
				MoveToEx(buf, CLX, CLY, NULL);
				x = ML * sin(newtime->tm_min * pi/30);
				y = ML * cos(newtime->tm_min * pi/30);
				LineTo(buf, CLX + (int)x, CLY - (int)y);
				SelectObject(buf, oldpen);

				oldpen = SelectObject(buf, SecondHandPen);
				switch (SecondHandMode)
				{
					case 0:
					{
						x = CR * sin(newtime->tm_sec * -pi/30);
						y = CR * cos(newtime->tm_sec * -pi/30);
						Arc(buf, (int)(CLX-x+SHR), (int)(CLY-y+SHR), (int)(CLX-x-SHR), (int)(CLY-y-SHR), (int)(SHR), (int)(SHR), (int)(SHR), (int)(SHR));
					}
					break;

					case 1: 
					{
						x = CR * sin(newtime->tm_sec * pi/30);
						y = CR * cos(newtime->tm_sec * pi/30);
						MoveToEx(buf, CLX, CLY, NULL);
						LineTo(buf, CLX + (int)x, CLY - (int)y);
					}
					break;

					case 2:
					{
						x = CR * sin(newtime->tm_sec * -pi/30);
						y = CR * cos(newtime->tm_sec * -pi/30);
						Arc(buf, CLX-CR, CLY-CR, CLX+CR, CLY+CR, (int)(CLX-x), (int)(CLY-y), CLX, CLX-CR);
					}
					break;

					case 3:
					{
						x = CR * sin(newtime->tm_sec * -pi/30);
						y = CR * cos(newtime->tm_sec * -pi/30);
						Arc(buf, CLX-CR, CLY-CR, CLX+CR, CLY+CR, CLX, CLY-CR, (int)(CLX-x), (int)(CLY-y));
					}
					break;
				}
				SelectObject(buf, oldpen);
			}

			BitBlt(hdc, 0, 0, W, H, buf, 0, 0, SRCCOPY);

			SelectObject(buf, oldbufbmp);
			DeleteObject(bufbmp);
			DeleteDC(buf);
			DeleteObject(oldbufbmp);
			DeleteObject(oldpen);
			SelectObject(src, oldsrcbmp);
			DeleteDC(src);
			DeleteObject(oldsrcbmp);
			EndPaint(hwnd, &ps);
		}
		break;

		case WM_TIMER:
		{
			switch ((int)wParam)
			{
				case 0:
				{
					InvalidateRect(hwnd, NULL, TRUE);
				}
				break;
			}
		}
		break;
	}

	return DefWindowProc(hwnd, msg, wParam, lParam);
}

void LoadSetup()
{
	char temp[256] = "";
	char path[256] = "";
	int pen_width;
	COLORREF pen_color;
	char* endstr;

	X = GetPrivateProfileInt(szAppName, "X", 0, cfgfile);
	Y = GetPrivateProfileInt(szAppName, "Y", 0, cfgfile);
	W = GetPrivateProfileInt(szAppName, "W", 100, cfgfile);
	H = GetPrivateProfileInt(szAppName, "H", 52, cfgfile);

	CR = GetPrivateProfileInt(szAppName, "ClockRadius", 0, cfgfile);
	CLX = GetPrivateProfileInt(szAppName, "ClockX", 0, cfgfile);
	CLY = GetPrivateProfileInt(szAppName, "ClockY", 0, cfgfile);
	HL = GetPrivateProfileInt(szAppName, "HourLength", 5, cfgfile);
	ML = GetPrivateProfileInt(szAppName, "MinuteLength", 10, cfgfile);
	TX = GetPrivateProfileInt(szAppName, "TimeX", 0, cfgfile);
	TY = GetPrivateProfileInt(szAppName, "TimeY", 0, cfgfile);
	WDX = GetPrivateProfileInt(szAppName, "WeekDayX", 0, cfgfile);
	WDY = GetPrivateProfileInt(szAppName, "WeekDayY", 0, cfgfile);
	DX = GetPrivateProfileInt(szAppName, "DateX", 0, cfgfile);
	DY = GetPrivateProfileInt(szAppName, "DateY", 0, cfgfile);
	MX = GetPrivateProfileInt(szAppName, "MonthX", 0, cfgfile);
	MY = GetPrivateProfileInt(szAppName, "MonthY", 0, cfgfile);
	AMPMX = GetPrivateProfileInt(szAppName, "AmPmX", 0, cfgfile);
	AMPMY = GetPrivateProfileInt(szAppName, "AmPmY", 0, cfgfile);
	SecondHandMode = GetPrivateProfileInt(szAppName, "SecondHandMode", 0, cfgfile);
	SHR = GetPrivateProfileInt(szAppName, "SecondHandRadius", 2, cfgfile);
	ANALOG = GetPrivateProfileInt(szAppName, "Analog", 1, cfgfile);
	DIGITAL = GetPrivateProfileInt(szAppName, "Digital", 1, cfgfile);

	pen_width = GetPrivateProfileInt(szAppName, "HourHandWidth", 1, cfgfile);
	GetPrivateProfileString(szAppName, "HourHandColor", "FFFFFF", temp, 256, cfgfile);
	pen_color = strtol( temp, &endstr, 16 );
	HourHandPen = CreatePen(PS_SOLID, pen_width, RGB(GetBValue(pen_color), GetGValue(pen_color), GetRValue(pen_color)));

	pen_width = GetPrivateProfileInt(szAppName, "MinuteHandWidth", 1, cfgfile);
	GetPrivateProfileString(szAppName, "MinuteHandColor", "FFFFFF", temp, 256, cfgfile);
	pen_color = strtol( temp, &endstr, 16 );
	MinuteHandPen = CreatePen(PS_SOLID, pen_width, RGB(GetBValue(pen_color), GetGValue(pen_color), GetRValue(pen_color)));

	pen_width = GetPrivateProfileInt(szAppName, "SecondHandWidth", 1, cfgfile);
	GetPrivateProfileString(szAppName, "SecondHandColor", "FFFFFF", temp, 256, cfgfile);
	pen_color = strtol( temp, &endstr, 16 );
	SecondHandPen = CreatePen(PS_SOLID, pen_width, RGB(GetBValue(pen_color), GetGValue(pen_color), GetRValue(pen_color)));

	GetPrivateProfileString("Main", "ImageDirectory", "c:\\winpanel\\images\\", IMAGE_DIR, MAX_PATH, cfgfile);	
	if (IMAGE_DIR[strlen(IMAGE_DIR)] != '\\')
	{
		IMAGE_DIR[strlen(IMAGE_DIR)] = '\\';
		IMAGE_DIR[strlen(IMAGE_DIR)+1] = '\0';
	}

	GetPrivateProfileString(szAppName, "Background", NULL, temp, 256, cfgfile);
	if (temp)
	{
		sprintf(path, "%s%s", IMAGE_DIR, temp);
		BG_IMAGE = LoadImage(NULL, path, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
	}

	GetPrivateProfileString(szAppName, "TextImage", NULL, temp, 256, cfgfile);
	if (temp)
	{
		sprintf(path, "%s%s", IMAGE_DIR, temp);
		TEXT_IMAGE = LoadImage(NULL, path, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);

		NUM_WIDTH = GetPrivateProfileInt(szAppName, "NumberWidth", 12, cfgfile);
		NUM_HEIGHT = GetPrivateProfileInt(szAppName, "NumberHeight", 12, cfgfile);
		LET_WIDTH = GetPrivateProfileInt(szAppName, "LetterWidth", 10, cfgfile);
		LET_HEIGHT = GetPrivateProfileInt(szAppName, "LetterHeight", 13, cfgfile);
	}
}